/*	@(#)dev_gp1.h 2.1 87/10/28 SMI	*/

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */


#ifndef	DEV_GP1_DEFINED
#define	DEV_GP1_DEFINED

#include <pixrect/gp1cmds.h>


typedef struct {
    float	x, y, z;
} Point3df;	/* a 3D floating-point point */

typedef struct {
    float	x, y;
} Point2df;	/* a 2D floating-point point */

typedef struct {
    int		x, y, z;
} Point3di;	/* a 3D integer point */

typedef struct {
    int		x, y;
} Point2di;	/* a 2D integer point */

typedef	struct {
    Point3di	p ;
    int		color ;
} Point3dic ;	/* a 3d integer point with color */

typedef	struct {
    Point3df	p ;
    int		color ;
} Point3dfc ;	/* a 3d floating-point point with color */

typedef	struct	{
    float	r,g,b ;
} Color ;

typedef	struct	{
    Point3df	p ;
    Color	c ;
} Point3dfrgb ;

typedef	struct	{
    Point3di	p ;
    Color	c ;
} Point3dirgb ;

typedef float	Matrix3df[4][4];

typedef float	Matrix2df[3][2];


#define	POINT2(p,x0,y0)		(p.x=(x0), p.y=(y0), &p)
#define	POINT3(p,x0,y0,z0)	(p.x=(x0), p.y=(y0), p.z=(z0), &p)






typedef struct _GP1 	*GP1_handle;

/* pixwin is not using the GP1 */
#define DEV_GP1_ERR_NO_GP1		1

/* can't allocate a context block */
#define DEV_GP1_ERR_NO_CONTEXT_BLK	2

/* can't allocate a texture block */
#define DEV_GP1_ERR_NO_TEXTURE_BLK	3

/* malloc failed */
#define DEV_GP1_ERR_NO_MEMORY		4

/* an ioctl call failed */
#define DEV_GP1_ERR_IOCTL		5

/* attempt to re-assign pixwin or pixrect to wrong gp */
#define	DEV_GP1_ERR_WRONG_GP		6




extern	GP1_handle	Dev_gp1_create();
extern	GP1_handle	Dev_gp1_create_pr();
extern	void		Dev_gp1_destroy();
extern	void		Dev_gp1_win_change();
extern	void		Dev_gp1_reset_to_defaults();
extern	void		Dev_gp1_flush();
extern	void		Dev_gp1_clear();
extern	void		Dev_gp1_setvp_3d();
extern	void		Dev_gp1_setvp_2d();
extern	void		Dev_gp1_viewport_2d() ;
extern	void		Dev_gp1_viewport_3d() ;
extern	void		Dev_gp1_set_color();
extern	void		Dev_gp1_set_write_mask();
extern	void		Dev_gp1_set_clip_planes();
extern	void		Dev_gp1_set_hidden_surf();
extern	void		Dev_gp1_set_rop_mode();
extern	void		Dev_gp1_set_z_buffer_depth();
extern	void		Dev_gp1_set_matrix_3d();
extern	void		Dev_gp1_set_matrix_2d();
extern	void		Dev_gp1_select_matrix();
extern	void		Dev_gp1_matrix_mul_2d();
extern	void		Dev_gp1_matrix_mul_3d();
extern	void		Dev_gp1_get_matrix_2d();
extern	void		Dev_gp1_get_matrix_3d();
extern	int		Dev_gp1_polygon_2df() ;
extern	int		Dev_gp1_polygon_2di() ;
extern	int		Dev_gp1_polygon_3df() ;
extern	int		Dev_gp1_polygon_3df_gouraud() ;
extern	int		Dev_gp1_polygon_3di() ;
extern	int		Dev_gp1_polygon_3di_gouraud() ;
extern	int		Dev_gp1_get_texture_block() ;
extern	void		Dev_gp1_free_texture_block() ;
extern	void		Dev_gp1_select_texture_block() ;
extern	void		Dev_gp1_set_texture_org_screen();
extern	void		Dev_gp1_set_texture_org_2df();
extern	void		Dev_gp1_set_texture_org_3df();
extern	int		Dev_gp1_set_polygon_texture();
extern	void		Dev_gp1_print();
extern	void		Dev_gp1_move_2di();
extern	void		Dev_gp1_draw_2di();
extern	void		Dev_gp1_move_2df();
extern	void		Dev_gp1_draw_2df();
extern	void		Dev_gp1_move_3di();
extern	void		Dev_gp1_draw_3di();
extern	void		Dev_gp1_move_3df();
extern	void		Dev_gp1_draw_3df();
extern	void		Dev_gp1_set_line_texture();
extern	void		Dev_gp1_set_line_width();
extern	void		Dev_gp1_set_dbuf() ;
extern	void		Dev_gp1_set_sbuf() ;
extern	void		Dev_gp1_putcolormap () ;
extern	void		Dev_gp1_dbuf_control() ;
extern	void		Dev_gp1_dbuf_write_mask() ;
extern	void		Dev_gp1_dbuf_color() ;
extern	void		Dev_gp1_dbuf_swap() ;
extern	int		Dev_gp1_dbuf_get_ctrl() ;
extern	int		Dev_gp1_dbuf_get_write_mask() ;
extern	void		Dev_gp1_line_2df() ;
extern	void		Dev_gp1_line_2di() ;
extern	void		Dev_gp1_line_3df() ;
extern	void		Dev_gp1_line_3di() ;
extern	void		Dev_gp1_mul_points() ;
extern	void		Dev_gp1_mul_term() ;
extern	int		Dev_gp1_mul_init_2df() ;
extern	void		Dev_gp1_mul_add_2df() ;
extern	void		Dev_gp1_mul_get_2df() ;
extern	void		Dev_gp1_mul_2df() ;
extern	int		Dev_gp1_mul_init_2di() ;
extern	void		Dev_gp1_mul_add_2di() ;
extern	void		Dev_gp1_mul_get_2di() ;
extern	void		Dev_gp1_mul_2di() ;
extern	int		Dev_gp1_mul_init_3df() ;
extern	void		Dev_gp1_mul_add_3df() ;
extern	void		Dev_gp1_mul_get_3df() ;
extern	void		Dev_gp1_mul_3df() ;
extern	int		Dev_gp1_mul_init_3di() ;
extern	void		Dev_gp1_mul_add_3di() ;
extern	void		Dev_gp1_mul_get_3di() ;
extern	void		Dev_gp1_mul_3di() ;
extern	void		Dev_gp1_ident_mat() ;
extern	void		Dev_gp1_xlate() ;
extern	void		Dev_gp1_rotx() ;
extern	void		Dev_gp1_roty() ;
extern	void		Dev_gp1_rotz() ;
extern	void		Dev_gp1_scale() ;
extern	void		Dev_gp1_persp() ;
extern	void		Dev_gp1_window_mat() ;
extern	void		Dev_gp1_point_transform3df() ;
extern	int		Dev_gp1_invert_mat() ;
extern	void		Dev_gp1_transpose_mat() ;
extern	void		Dev_gp1_wait() ;
extern	void		Dev_gp1_setcmsname() ;
extern	void		Dev_gp1_getcmsname() ;
extern	void		Dev_gp1_putcolormap() ;
extern	void		Dev_gp1_getcolormap() ;
extern	struct pixwin	*Dev_gp1_get_pw() ;
extern	struct pixrect	*Dev_gp1_get_pr() ;
extern	struct rect	*Dev_gp1_rect() ;


#endif	DEV_GP1_DEFINED
