#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_clear.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */

/******
 * Dev_gp1_clear
 *
 * use the pixrect function GP1_PRROPNF to paint rectangles.  Rectangle
 * list is taken from cliplist.
 *
 ******/


#include "dev_gp1_internal.h"




void
Dev_gp1_clear(gp1, color)
register	GP1	*gp1;
 		int		color;
{
register short	*ptr;
register short	rop ;
register Rect	*rptr ;
register int	i ;

	if(gp1->r0 != NULL)
	    color = DEV_GP1_DBUF_GET_COLOR(gp1,color) ;

	ptr = gp1->out_buffer.cur_ptr ;
	rop = PIX_SRC | PIX_COLOR(color);


	/*
	 * Lock in order to get the most up-to-date cliplist.
	 */
	DEV_GP1_LOCK(gp1) ;
	(*gp1->clipfunc)(gp1,0) ;

	for( rptr = gp1->cliplist, i=gp1->nclip; --i >= 0; )
	{				/* for each clip list rect */
	    if (!GP1_ISROOM(gp1, 11))
	    {
		Dev_gp1_flush(gp1, TRUE);
		ptr = gp1->out_buffer.cur_ptr;
	    }
	    *ptr++ = GP1_PRROPNF | gp1->realmask ;
	    *ptr++ = gp1->fbi; 			/* frame buffer index */
	    *ptr++ = rop;			/* rop and color */
	    *ptr++ = rptr->r_left;		/* X, Y origin of rect */
	    *ptr++ = rptr->r_top;
	    *ptr++ = rptr->r_width;		/* X, Y size of rect */
	    *ptr++ = rptr->r_height;
	    *ptr++ = 0;				/* w/r to clip pixrect */
	    *ptr++ = 0;
	    *ptr++ = rptr->r_width;
	    *ptr++ = rptr->r_height;
	    ++rptr ;				/* go to next one */
	    GP1_USEUP(gp1, 11) ;
	}

	/*
	 * Since we have a lock, go ahead and flush.
	 */
	Dev_gp1_flush(gp1, TRUE);
	DEV_GP1_UNLOCK(gp1);
}
