#ifndef lint
static	char sccsid[] = "%Z%%M% %I% %E% SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */

/******
 * Dev_gp1_clear_vp
 *
 * clear part of the window instead of all of it.
 *
 * use the pixrect function GP1_PRROPNF to paint rectangles.  Rectangle
 * list is taken from cliplist.
 *
 ******/


#include "dev_gp1_internal.h"




void
Dev_gp1_clear_vp(gp1, color, vx0,vx1,vy0,vy1)
register	GP1	*gp1;
 		int	color;
		float	vx0,vx1,vy0,vy1 ;
{
register	Rect	*rptr ;
register	short	*ptr;
		short	rop ;
register	int	x2,y2,x3,y3 ;
register	int	x0,y0,x1,y1 ;
		int	i ;

	if(gp1->r0 != NULL)
	    color = DEV_GP1_DBUF_GET_COLOR(gp1,color) ;

	ptr = gp1->out_buffer.cur_ptr ;
	rop = PIX_SRC | PIX_COLOR(color);


	/*
	 * Lock in order to get the most up-to-date cliplist.
	 */
	DEV_GP1_LOCK(gp1) ;
	(*gp1->clipfunc)(gp1,0) ;

	/*
	 * find bounds of viewport in pixel coords.
	 */
	x0 = vx0 * gp1->win_size.r_width + gp1->win_org_x ;
	y0 = gp1->win_size.r_height -
	     vy1 * gp1->win_size.r_height + gp1->win_org_y ;
	x1 = vx1 * gp1->win_size.r_width + gp1->win_org_x ;
	y1 = gp1->win_size.r_height -
	     vy0 * gp1->win_size.r_height + gp1->win_org_y ;

	/*
	 * do the poor slob a favor and sort them
	 */
	if(x0 > x1)
	{
	  register int tmp = x0 ;
	  x0 = x1 ;
	  x1 = tmp ;
	}
	if(y0 > y1)
	{
	  register int tmp = y0 ;
	  y0 = y1 ;
	  y1 = tmp ;
	}

	for( rptr = gp1->cliplist, i = gp1->nclip; --i >= 0; )
	{				/* for each clip list rect */
	    /*
	     * get clip rectangle
	     */
	    x2 = rptr->r_left ;
	    y2 = rptr->r_top ;
	    x3 = x2 + rptr->r_width ;
	    y3 = y2 + rptr->r_height ;

	    /*
	     * clip viewport against it
	     */
	    if(x0 > x2) x2 = x0 ;
	    if(x1 < x3) x3 = x1 ;
	    if(y0 > y2) y2 = y0 ;
	    if(y1 < y3) y3 = y1 ;

	    /*
	     * and write out if non-null
	     */
	    if((x3 -= x2) > 0  &&  (y3 -= y2) > 0)
	    {
		if (!GP1_ISROOM(gp1, 11))
		{
		    Dev_gp1_flush(gp1, TRUE);
		    ptr = gp1->out_buffer.cur_ptr;
		}
		*ptr++ = GP1_PRROPNF | gp1->realmask ;
		*ptr++ = gp1->fbi; 	/* frame buffer index */
		*ptr++ = rop;		/* rop and color */
		*ptr++ = x2 ;		/* X, Y origin of rect */
		*ptr++ = y2 ;
		*ptr++ = x3 ;		/* X, Y size of rect */
		*ptr++ = y3 ;
		*ptr++ = 0;		/* w/r to clip pixrect */
		*ptr++ = 0;
		*ptr++ = x3 ;
		*ptr++ = y3 ;
		GP1_USEUP(gp1, 11) ;
	    }
	    ++rptr ;			/* go to next one */
	}

	/*
	 * Since we have a lock, go ahead and flush.
	 */
	Dev_gp1_flush(gp1, TRUE);
	DEV_GP1_UNLOCK(gp1);
}
