#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_color.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include "dev_gp1_internal.h"


/*
 *	These routines handle color-table double buffering
 *
 *
 *	Routines provided here:
 *
 *
 *	Dev_gp1_setcmsname(gp1, cmsname)
 *		Set cms name
 *
 *	Dev_gp1_getcmsname(gp1, cmsname)
 *		Get cms name
 *
 *	Dev_gp1_putcolormap(gp1, start, length, r,g,b)
 *		same as pw_putcolormap or pr_putcolormap
 *
 *	Dev_gp1_getcolormap(gp1, start, length, r,g,b)
 *		Retrieve the gp's color map
 *
 *
 *
 *	Edward A. Falk
 *	Sun Microsystems
 *
 *	Sept, 1987
 *
 *
 *
 */

#include "dev_gp1_internal.h"

/****
 *
 * Constants,  typedefs, externals, globals, statics, macros, block data
 *
 ****/



void
Dev_gp1_setcmsname(gp1, name)
register GP1	*gp1 ;
	char	*name ;
{
	(*gp1->setcms)(gp1, 0, name) ;
}



void
Dev_gp1_getcmsname(gp1, name)
register GP1	*gp1 ;
	char	name[CMS_NAMESIZE] ;
{
	(*gp1->setcms)(gp1, 1, name) ;
}







void
Dev_gp1_putcolormap(gp1, start, length, r,g,b)
register GP1		*gp1 ;
	int		start ;
	int		length ;
	unsigned char	*r, *g, *b ;
{
	int	i,j ;
	struct colormapseg	cms ;

	(*gp1->putcmap)(gp1, 0, start, length, r,g,b) ;
}



void
Dev_gp1_getcolormap(gp1, start, length, r,g,b)
register GP1		*gp1 ;
	int		start ;
	int		length ;
	unsigned char	*r, *g, *b ;
{
	(*gp1->putcmap)(gp1, 1, start, length, r,g,b) ;
}
