#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_destroy.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */



#include "dev_gp1_internal.h"


/* 
 * Free resources used by the GP1:
 *    1) Write a cmd at the start of the 1st cmd block which
 * 	frees all the blocks. Do not flush the buffer.
 *    2) Free the static block via an ioctl.
 */

void
Dev_gp1_destroy(gp1)
register	GP1	*gp1;
{  
    register	short		*ptr;

    Dev_gp1_flush(gp1, 0) ;

    GP1_PUT_SHORT(gp1, GP1_EOCL | GP1_FREEBLKS) ;
    GP1_PUT_INT(gp1, gp1->out_buffer.bitvec) ;
    gp1_post(gp1->shmem, gp1->out_buffer.bufoffset, gp1->fd);

    if(gp1->tmp_buffer.gpbuffer != NULL)
    {
	GP1_PUT_SHORT(gp1, GP1_EOCL | GP1_FREEBLKS) ;
	GP1_PUT_INT(gp1, gp1->tmp_buffer.bitvec) ;
	gp1_post(gp1->shmem, gp1->tmp_buffer.bufoffset, gp1->fd);
    }

    gp1_free_static_block(gp1->fd, gp1->static_block);

    if(gp1->pattern_block >= 0)
	gp1_free_static_block(gp1->fd, gp1->pattern_block);
    
    if(gp1->r0) free(gp1->r0) ;
    if(gp1->g0) free(gp1->g0) ;
    if(gp1->b0) free(gp1->b0) ;
    if(gp1->r1) free(gp1->r1) ;
    if(gp1->g1) free(gp1->g1) ;
    if(gp1->b1) free(gp1->b1) ;

    free(gp1);
}
