#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_get_mat.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */

/*
 * This file contains routines for retrieving 3d and 2d
 * matrices.  And for selecting the current matrix.
 */

#include "dev_gp1_internal.h"




static	void
get_matrix(gp1, index, mat, cmd, len)
register GP1	*gp1 ;
	 int	index ;
register short	*mat ;
	 short	cmd ;
register int	len ;
{
register short	*ptr ;
	Gpbuf	tmp_buffer ;


	if(gp1->flags & (1<<index))		/* we have to flush */
	{
	    gp1->list_type = GP1_NO_LIST;	/* close any list in process */
	    MAKE_ROOM(gp1, 2+len) ;
	    GP1_PUT_SHORT(gp1, cmd | (index & 0xff)) ;
	    ptr = gp1->out_buffer.cur_ptr ;
	    GP1_PUT_SHORT(gp1, 0xff) ;		/* ready flag */
	    GP1_USEUP(gp1, len) ;
	    Dev_gp1_flush(gp1,FALSE) ;
	    gp1_wait0(ptr, gp1->fd);	/* wait for gp1 to process cmds */
	    ++ptr ;
	    while(len-- > 0)
		*mat++ = *ptr++ ;
	}
	else
	{
	    _gp1_alloc_buffers(gp1, &tmp_buffer) ;
	    GP1_PUT_SHORT_B(tmp_buffer, cmd | (index & 0xff)) ;
	    ptr = tmp_buffer.cur_ptr ;
	    GP1_PUT_SHORT_B(tmp_buffer, 0xff) ;		/* ready flag */
	    GP1_USEUP_B(tmp_buffer, len) ;
	    GP1_PUT_SHORT_B(tmp_buffer, GP1_EOCL) ;
	    gp1_post(gp1->shmem, tmp_buffer.bufoffset, gp1->fd) ;
	    gp1_wait0(ptr, gp1->fd);	/* wait for gp1 to process cmds */
	    ++ptr ;
	    while(len-- > 0)
		*mat++ = *ptr++ ;
	    GP1_INT_BUFCLEAR(gp1, tmp_buffer) ;
	    tmp_buffer.cur_ptr = tmp_buffer.gpbuffer ;
	    GP1_PUT_SHORT_B(tmp_buffer, GP1_EOCL | GP1_FREEBLKS) ;
	    GP1_PUT_INT_B(tmp_buffer, tmp_buffer.bitvec) ;
	    gp1_post(gp1->shmem, tmp_buffer.bufoffset, gp1->fd) ;
	}
}




void
Dev_gp1_get_matrix_2d(gp1, index, mat)
register	GP1		*gp1;
 		int		index;
 		Matrix2df	mat;
{
	get_matrix(gp1, index, (short *)mat, GP1_GET_MAT_2D,
	    sizeof(Matrix2df)/sizeof(short)) ;
}




void
Dev_gp1_get_matrix_3d(gp1, index, mat)
register	GP1		*gp1;
 		int		index;
 		Matrix3df	mat;
{
	get_matrix(gp1, index, (short *)mat, GP1_GET_MAT_3D,
	    sizeof(Matrix3df)/sizeof(short)) ;
}
