/*	@(#)dev_gp1_mac.h 2.1 87/10/28 SMI	*/

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */


#ifndef	DEV_GP1_MAC
#define	DEV_GP1_MAC


#ifndef	DEV_GP1_INTERNAL
#include "dev_gp1_internal.h"
#endif	DEV_GP1_INTERNAL



#define	Dev_gp1_lock(gp1, rect)	\
	{ if( (gp1)->lockfunc != NULL )	\
	    (*(gp1)->lockfunc)((gp1),(rect)) ; }

#define	Dev_gp1_unlock(gp1)	\
	{ if( (gp1)->unlockfunc != NULL )	\
	    (*(gp1)->unlockfunc)(gp1) ; }




/*
 * Macros for setting attributes.
 */

#define Dev_gp1_set_color		DEV_GP1_SET_COLOR
#define Dev_gp1_rgbcolor		DEV_GP1_RGBCOLOR
#define Dev_gp1_rgbpacked		DEV_GP1_RGBPACKED
#define Dev_gp1_set_clip_planes		DEV_GP1_SET_CLIP_PLANES
#define	Dev_gp1_set_hidden_surf		DEV_GP1_SET_HIDDEN_SURF
#define	Dev_gp1_set_rop_mode		DEV_GP1_SET_ROP_MODE
#define	Dev_gp1_set_line_width		DEV_GP1_SET_LINE_WIDTH
#define	Dev_gp1_dbuf_color 		DEV_GP1_DBUF_COLOR
#define	Dev_gp1_dbuf_get_color		DEV_GP1_DBUF_GET_COLOR
#define Dev_gp1_set_texture_org_screen	DEV_GP1_SET_TEXTURE_ORG_SCREEN
#define Dev_gp1_set_texture_org_2df	DEV_GP1_SET_TEXTURE_ORG_2DF
#define Dev_gp1_set_texture_org_3df	DEV_GP1_SET_TEXTURE_ORG_3DF
#define	Dev_gp1_select_texture_block	DEV_GP1_SELECT_TEXTURE_BLOCK
#define	DEV_GP1_SET_WRITE_MASK		Dev_gp1_set_write_mask



/*
 * Macros for matrix handling
 */

#define	Dev_gp1_select_matrix	DEV_GP1_SELECT_MATRIX
#define	Dev_gp1_matrix_mul_2d	DEV_GP1_MATRIX_MUL_2D
#define	Dev_gp1_matrix_mul_3d	DEV_GP1_MATRIX_MUL_3D
#define	Dev_gp1_matrix_copy	DEV_GP1_MATRIX_COPY



/*
 * Macros for stuffing polygons into the gp1.
 */

#define	Dev_gp1_poly_2di_init		DEV_GP1_POLY_2DI_INIT
#define	Dev_gp1_poly_2di_init_tex	DEV_GP1_POLY_2DI_INIT_TEX
#define Dev_gp1_poly_2di_add_bound	DEV_GP1_POLY_2DI_ADD_BOUND
#define Dev_gp1_poly_2di_add_vertex	DEV_GP1_POLY_2DI_ADD_VERTEX

#define	Dev_gp1_poly_2df_init		DEV_GP1_POLY_2DF_INIT
#define	Dev_gp1_poly_2df_init_tex	DEV_GP1_POLY_2DF_INIT_TEX
#define Dev_gp1_poly_2df_add_bound	DEV_GP1_POLY_2DF_ADD_BOUND
#define Dev_gp1_poly_2df_add_vertex	DEV_GP1_POLY_2DF_ADD_VERTEX

#define	Dev_gp1_poly_3di_init		DEV_GP1_POLY_3DI_INIT
#define	Dev_gp1_poly_3di_init_tex	DEV_GP1_POLY_3DI_INIT_TEX
#define	Dev_gp1_poly_3di_init_gouraud	DEV_GP1_POLY_3DI_INIT_GOURAUD
#define Dev_gp1_poly_3di_add_bound	DEV_GP1_POLY_3DI_ADD_BOUND
#define Dev_gp1_poly_3di_add_vertex	DEV_GP1_POLY_3DI_ADD_VERTEX
#define Dev_gp1_poly_3di_add_vertex_gouraud		\
				DEV_GP1_POLY_3DI_ADD_VERTEX_GOURAUD

#define	Dev_gp1_poly_3df_init		DEV_GP1_POLY_3DF_INIT
#define	Dev_gp1_poly_3df_init_tex	DEV_GP1_POLY_3DF_INIT_TEX
#define	Dev_gp1_poly_3df_init_gouraud	DEV_GP1_POLY_3DF_INIT_GOURAUD
#define Dev_gp1_poly_3df_add_bound	DEV_GP1_POLY_3DF_ADD_BOUND
#define Dev_gp1_poly_3df_add_vertex	DEV_GP1_POLY_3DF_ADD_VERTEX
#define Dev_gp1_poly_3df_add_vertex_gouraud		\
				DEV_GP1_POLY_3DF_ADD_VERTEX_GOURAUD

#define	Dev_gp2_poly_3di_init		DEV_GP2_POLY_3DI_INIT
#define	Dev_gp2_poly_3di_init_tex	DEV_GP2_POLY_3DI_INIT_TEX
#define	Dev_gp2_poly_3di_init_rgb	DEV_GP2_POLY_3DI_INIT_RGB
#define	Dev_gp2_poly_3di_init_packed	DEV_GP2_POLY_3DI_INIT_PACKED
#define Dev_gp2_poly_3di_add_bound	DEV_GP2_POLY_3DI_ADD_BOUND
#define Dev_gp2_poly_3di_add_vertex	DEV_GP2_POLY_3DI_ADD_VERTEX
#define Dev_gp1_poly_3di_add_vertex_rgb	DEV_GP2_POLY_3DI_ADD_VERTEX_RGB
#define Dev_gp1_poly_3di_add_vertex_packed		\
					DEV_GP2_POLY_3DI_ADD_VERTEX_PACKED

#define	Dev_gp2_poly_3df_init		DEV_GP2_POLY_3DF_INIT
#define	Dev_gp2_poly_3df_init_tex	DEV_GP2_POLY_3DF_INIT_TEX
#define	Dev_gp2_poly_3df_init_rgb	DEV_GP2_POLY_3DF_INIT_RGB
#define	Dev_gp2_poly_3df_init_packed	DEV_GP2_POLY_3DF_INIT_PACKED
#define Dev_gp2_poly_3df_add_bound	DEV_GP2_POLY_3DF_ADD_BOUND
#define Dev_gp2_poly_3df_add_vertex	DEV_GP2_POLY_3DF_ADD_VERTEX
#define Dev_gp2_poly_3df_add_vertex_rgb	DEV_GP2_POLY_3DF_ADD_VERTEX_RGB
#define Dev_gp2_poly_3df_add_vertex_packed		\
					DEV_GP2_POLY_3DF_ADD_VERTEX_PACKED



/*
 * VECTORS
 */

#define Dev_gp1_move_2di	DEV_GP1_MOVE_2DI
#define Dev_gp1_draw_2di	DEV_GP1_DRAW_2DI
#define	Dev_gp1_vec_init_2di	DEV_GP1_VEC_INIT_2DI
#define	Dev_gp1_vec_move_2di	DEV_GP1_VEC_MOVE_2DI
#define	Dev_gp1_vec_draw_2di	DEV_GP1_VEC_DRAW_2DI
#define	Dev_gp1_vec_term_2di	DEV_GP1_VEC_TERM_2DI

#define Dev_gp1_move_2df	DEV_GP1_MOVE_2DF
#define Dev_gp1_draw_2df	DEV_GP1_DRAW_2DF
#define	Dev_gp1_vec_init_2df	DEV_GP1_VEC_INIT_2DF
#define	Dev_gp1_vec_move_2df	DEV_GP1_VEC_MOVE_2DF
#define	Dev_gp1_vec_draw_2df	DEV_GP1_VEC_DRAW_2DF
#define	Dev_gp1_vec_term_2df	DEV_GP1_VEC_TERM_2DF

#define Dev_gp1_move_3di	DEV_GP1_MOVE_3DI
#define Dev_gp1_draw_3di	DEV_GP1_DRAW_3DI
#define	Dev_gp1_vec_init_3di	DEV_GP1_VEC_INIT_3DI
#define	Dev_gp1_vec_move_3di	DEV_GP1_VEC_MOVE_3DI
#define	Dev_gp1_vec_draw_3di	DEV_GP1_VEC_DRAW_3DI
#define	Dev_gp1_vec_term_3di	DEV_GP1_VEC_TERM_3DI

#define Dev_gp1_move_3df	DEV_GP1_MOVE_3DF
#define Dev_gp1_draw_3df	DEV_GP1_DRAW_3DF
#define	Dev_gp1_vec_init_3df	DEV_GP1_VEC_INIT_3DF
#define	Dev_gp1_vec_move_3df	DEV_GP1_VEC_MOVE_3DF
#define	Dev_gp1_vec_draw_3df	DEV_GP1_VEC_DRAW_3DF
#define	Dev_gp1_vec_term_3df	DEV_GP1_VEC_TERM_3DF


/*
 * TRANSFORM POINTS
 */

#define	Dev_gp1_mul_points	DEV_GP1_MUL_POINTS

#define	Dev_gp1_mul_add_2di	DEV_GP1_MUL_ADD_2DI
#define	Dev_gp1_mul_get_2di	DEV_GP1_MUL_GET_2DI

#define	Dev_gp1_mul_add_2df	DEV_GP1_MUL_ADD_2DF
#define	Dev_gp1_mul_get_2df	DEV_GP1_MUL_GET_2DF

#define	Dev_gp1_mul_add_3di	DEV_GP1_MUL_ADD_3DI
#define	Dev_gp1_mul_get_3di	DEV_GP1_MUL_GET_3DI

#define	Dev_gp1_mul_add_3df	DEV_GP1_MUL_ADD_3DF
#define	Dev_gp1_mul_get_3df	DEV_GP1_MUL_GET_3DF


#endif	DEV_GP1_MAC
