#ifndef lint
static  char sccsid[] = "@(#)dev_gp1_mat.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

/*
 * This file contains routines for setting and retrieving 3d and 2d
 * matrices.  And for selecting the current matrix.
 */

#include "dev_gp1_internal.h"

static	void	get_mat();


void
Dev_gp1_set_matrix_3d(gp1, index, mat)
register GP1		*gp1;
 	int		index;
	Matrix3df	mat;
{
register short		*ptr, *mptr ;
register int		cnt ;

	gp1->list_type = GP1_NO_LIST;	/* close any list in process */
	gp1->flags |= 1 << index ;	/* indicate matrix is changed */

	MAKE_ROOM(gp1, 1 + sizeof(Matrix3df)/sizeof(short));

	ptr = gp1->out_buffer.cur_ptr ;
	mptr = (short *) mat ;
	cnt = sizeof(Matrix3df)/sizeof(short) ;
	*ptr++ = GP1_SET_MATRIX_3D | (index & 0xff) ;
	while(cnt-- > 0)
	    *ptr++ = *mptr++ ;

	GP1_USEUP(gp1, 1 + sizeof(Matrix3df)/sizeof(short)) ;
}




void
Dev_gp1_set_matrix_2d(gp1, index, mat)
register	GP1		*gp1;
 		int		index;
 		Matrix2df	mat;
{
register short		*ptr, *mptr ;
register int		cnt ;

	gp1->list_type = GP1_NO_LIST;	/* close any list in process */
	gp1->flags |= 1 << index ;	/* indicate matrix is changed */

	MAKE_ROOM(gp1, 1 + sizeof(Matrix2df)/sizeof(short));

	ptr = gp1->out_buffer.cur_ptr ;
	mptr = (short *) mat ;
	cnt = sizeof(Matrix2df)/sizeof(short) ;
	*ptr++ = GP1_SET_MATRIX_2D | (index & 0xff) ;
	while(cnt-- > 0)
	    *ptr++ = *mptr++ ;

	GP1_USEUP(gp1, 1 + sizeof(Matrix2df)/sizeof(short)) ;
}




void
Dev_gp1_matrix_mul_2d(gp1, result, a, b)
register GP1	*gp1;
 	int	result, a, b;
{
	DEV_GP1_MATRIX_MUL_2D(gp1, result, a, b) ;
}


void
Dev_gp1_matrix_mul_3d(gp1, result, a, b)
register	GP1	*gp1;
 		int	result, a, b;
{
	DEV_GP1_MATRIX_MUL_3D(gp1, result, a, b) ;
}



#ifdef	GP1_COPY_MAT
Dev_gp1_matrix_copy(gp1,src,dst)
register GP1	*gp1 ;
	int	src,dst ;
{
	DEV_GP1_MATRIX_COPY(gp1,src,dst) ;
}
#endif	GP1_COPY_MAT
