#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_mul_2df.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include "dev_gp1_internal.h"


/*
 *		TRANSFORM ROUTINES
 *
 * Dev_gp1_mul_init_2df(gp1)			open transform block
 *						return # points that will fit
 *
 * Dev_gp1_mul_add_2df(gp1, x, y)		add a point to transform block
 *	float	x,y ;
 *
 * Dev_gp1_mul_get_2df(gp1, &x, &y)		get a transformed point
 *
 * Dev_gp1_mul_2df(gp1, npts, pts, retain)	transform an array of points
 */



int
Dev_gp1_mul_init_2df(gp)
register GP1	*gp ;
{
	/* if current matrix is in the pipe, flush it through */

	if(gp->flags & 1 << gp->cur_matrix)
	  Dev_gp1_flush(gp,1) ;

	if(gp->tmp_buffer.gpbuffer == NULL)
	    _gp1_alloc_buffers(gp, &gp->tmp_buffer) ;
	else
	{
	    GP1_INT_BUFCLEAR(gp, gp->tmp_buffer) ;
	}

	GP1_PUT_SHORT_B(gp->tmp_buffer, GP1_MUL_POINT_FLT_2D) ;
	gp->bound_ptr = gp->tmp_buffer.cur_ptr ;
	GP1_PUT_SHORT_B(gp->tmp_buffer, 0) ;


	return ( gp->tmp_buffer.words_left / SIZE_T2DF ) ;
}





void
Dev_gp1_mul_add_2df(gp1, x, y)
register GP1	*gp1 ;
	float	x,y ;
{
	DEV_GP1_MUL_ADD_2DF(gp1, x, y) ;
}





void
Dev_gp1_mul_get_2df(gp1, x, y)
register GP1	*gp1 ;
	float	*x, *y ;
{
	DEV_GP1_MUL_GET_2DF(gp1, *x, *y) ;
}





void
Dev_gp1_mul_2df(gp1, npts, pts, retain)
register GP1		*gp1 ;
	int		npts ;
register Point2df	*pts ;
	int		retain ;
{
register Point2df	*result ;
register int		fit, cnt ;


	while(npts > 0)
	{
	    fit = Dev_gp1_mul_init_2df(gp1) ;
	    if(fit > npts)
		fit = npts ;
	    cnt = fit ;
	    result = pts ;
	    while(cnt-- > 0)
	    {
		DEV_GP1_MUL_ADD_2DF(gp1, pts->x, pts->y) ;
		++pts ;
	    }
	    DEV_GP1_MUL_POINTS(gp1) ;
	    cnt = fit ;
	    while(cnt-- > 0)
	    {
		DEV_GP1_MUL_GET_2DF(gp1, result->x, result->y) ;
		++result ;
	    }
	    npts -= fit ;
	}

	if(!retain)
	    Dev_gp1_mul_term(gp1) ;
}
