#ifndef lint
static	char sccsid[] = "@(#)dev_gp1_poly_texture.c 2.1 87/10/28 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include "dev_gp1_internal.h"



void
Dev_gp1_set_texture_org_screen(gp1, x, y)
	GP1	*gp1;
	int	x, y;
{
	DEV_GP1_SET_TEXTURE_ORG_SCREEN(gp1, x, y) ;
}




void
Dev_gp1_set_texture_org_2df(gp1, x, y)
	GP1	*gp1;
	float	x, y;
{
	DEV_GP1_SET_TEXTURE_ORG_2DF(gp1, x, y) ;
}



void
Dev_gp1_set_texture_org_3df(gp1, x, y, z)
	GP1	*gp1;
	float	x, y, z;
{
	DEV_GP1_SET_TEXTURE_ORG_3DF(gp1, x, y, z) ;
}




int
Dev_gp1_get_texture_block(gp1)
	GP1	*gp1 ;
{
	int	texture_block ;

	return  gp1_get_static_block(gp1->fd) ;
}




void
Dev_gp1_free_texture_block(gp1,block)
	GP1	*gp1 ;
	int	block ;
{
	gp1_free_static_block(gp1->fd, block) ;
	if(gp1->pattern_block == block)
	    gp1->pattern_block = -1 ;
}



void
Dev_gp1_select_texture_block(gp1,block)
	GP1	*gp1 ;
	int	block ;
{
	DEV_GP1_SELECT_TEXTURE_BLOCK(gp1, block) ;
}




int
Dev_gp1_set_polygon_texture(gp1, pr)
 	 	GP1		*gp1;
register	Pixrect		*pr;
{
register	short		*ptr;
register	int		total_words;
		short		*Dev_gp1_load_texture();
register	short		*data;		/* data from the pixrect */
register	short		*row_start;	/* start of a row in the
						 * pixrect.
						 */
register	int		line_shorts;	/* number of shorts from
						 * (x, y) to (x, y+1).
						 */
register	int		row_shorts;	/* number of shorts
						 * (16 bit words) on a row
						 * of the pixrect.
						 */
		struct mpr_data	*mprd;		/* memory pixrect data */
		Pixrect		*new_pr ;
register	int		i, row;

	if(gp1->pattern_block == -1)
	{
	    gp1->pattern_block = gp1_get_static_block(gp1->fd) ;
	    DEV_GP1_SELECT_TEXTURE_BLOCK(gp1, gp1->pattern_block) ;
	}



	if (pr->pr_depth == 1)
	    total_words = ((pr->pr_size.x + 15) >> 4) * pr->pr_size.y;
	else
	    total_words = ((pr->pr_size.x + 1) >> 1) * pr->pr_size.y;

	if (total_words > GP1_WORDS_PER_BLOCK)
	    return(-1);	/* cannot fit texture in texture block */

	total_words += 4 ;

	MAKE_ROOM(gp1, total_words);
	if(!GP1_ISROOM(gp1,total_words))
	    return(-1) ;	/* cannot fit texture in command buffer */

	gp1->list_type = GP1_NO_LIST;

	ptr = gp1->out_buffer.cur_ptr;

	*ptr++ = GP1_SET_PGON_TEX;



	if (MP_NOTMPR(pr) || (mpr_d(pr)->md_offset.x != 0)) {
	    /*
	     * There is an X offset, or the pixrect is not a memory pixrect.
	     * In either case, I do not want to deal with it. So, create
	     * a new memory pixrect which is easier to deal with.
	     */
	    new_pr = mem_create(pr->pr_size.x, pr->pr_size.y, pr->pr_depth);
	    pr_rop(new_pr, 0, 0, pr->pr_size.x, pr->pr_size.y,
		   PIX_SRC,
		   pr, 0, 0);
	    pr = new_pr;
	}
	else
	    new_pr = NULL;


	mprd = mpr_d(pr);
	line_shorts = mprd->md_linebytes >> 1;

	if (mprd->md_offset.y == 0)
	    row_start = mprd->md_image;
	else
	    row_start = mprd->md_image + (line_shorts * mprd->md_offset.y);

	if (pr->pr_depth == 1)
	    row_shorts = (pr->pr_size.x + 15) >> 4;
	else
	    row_shorts = (pr->pr_size.x + 1) >> 1;

	*ptr++ = (short)pr->pr_depth;
	*ptr++ = (short)pr->pr_size.x;
	*ptr++ = (short)pr->pr_size.y;

	if (row_shorts != line_shorts) {
	    for (row = 0; row < pr->pr_size.y; row++) {
		data = row_start;
		for (i = 0; i < row_shorts; i++)
		    *ptr++ = *data++;

		row_start += line_shorts;
	    }
	}
	else {
	    i = pr->pr_size.y * line_shorts;
	    data = row_start;
	    while (i--)
		*ptr++ = *data++;
	}

	if (new_pr)
	    pr_destroy(new_pr);

	GP1_USEUP(gp1, ptr - gp1->out_buffer.cur_ptr) ;

	return(0);
}
