#ifndef lint
static	char	sccsid[] =
"%Z%%M% %I% %E% 58te gfx lib.  Copyr 1987 Sun Micro";
#endif

/**********
 *
 *
 *	 @@@   @@@@   @@@@	    @@@@   @@@@	   @@@	 @   @	@@@@@
 *	@      @   @  @	  @	    @	@  @   @    @	 @@  @	  @
 *	@ @@@  @@@@   @@@@	    @@@@   @@@@	    @	 @ @ @	  @
 *	@   @  @      @	  @	    @	   @  @	    @	 @  @@	  @
 *	 @@@@  @      @@@@   @@@@@  @	   @   @   @@@	 @   @	  @
 *
 *	GPB_PRINT - print a gp buffer
 *
 *	This routine accepts start & end pointers in memory and prints
 *	the gp buffer they point to.
 *
 *
 *	Routines provided here:
 *
 *
 *	gpb_print (start,end)
 *		short	*start, *end
 *
 *
 *
 *	Edward A. Falk
 *	Sun Microsystems
 *
 *	November, 1986
 *
 *
 *
 *
 *
 *
 **********/

#include <stdio.h>
#include <pixrect/pixrect_hs.h>

#ifndef	GP1CMDS
#include <pixrect/gp1cmds.h>
#else	GP1CMDS
#include "gp1cmds.h"
#endif	GP1CMDS



#define GP_MOVE_FLAG	1
#define GP_END_FLAG	0x8000

#define	MAX_BNDS	40


typedef union {
	  char		 *ch;
	  float		 *fl;
	  short		 *sh;
	  int		 *in
	} PTR;


	PTR		ptr;


#ifndef GP1_PUT_F

/*
 * MACROS DEFINED IN 4.x
 */

#ifdef	mc68000

#define GP1_PUT_I(p,a)	( *((long *)(p))++ = (long)(a) )
#define GP1_PUT_F(p,a)	( *((float *)(p))++ = (float)(a) )
#define GP1_GET_I(p,a)	( (a) = *((long *)(p))++ )
#define GP1_GET_F(p,a)	( (a) = *((float *)(p))++ )

#else	mc68000

#define	GP1_PUT_F(p, a)	(((short *) (p))[0] = ((short *)&(a))[0], \
				((short *) (p))[1] = ((short *) &(a))[1] , \
				(p) += sizeof (float) / sizeof *(p))

#define	GP1_PUT_I(p, a)	(((short *) (p))[0] = ((short *)&(a))[0], \
				((short *) (p))[1] = ((short *) &(a))[1], \
				(p) += sizeof (int) / sizeof *(p))

#define	GP1_GET_F(p, a)	(((short *) &(a))[0] = ((short *)(p))[0], \
				((short *) &(a))[1] = ((short *) (p))[1], \
				(p) += sizeof (float) / sizeof *(p))

#define	GP1_GET_I(p, a)	(((short *) &(a))[0] = ((short *)(p))[0], \
				((short *) &(a))[1] = ((short *) (p))[1], \
				(p) += sizeof (int) / sizeof *(p))

#endif	mc68000

#endif	GP1_PUT_F







int		vpdbg = 0;	/* debug flag */



gpb_print(pointer, end_ptr)
	short	*pointer, *end_ptr;
{


	int		i, n, exit_at_eocl;
	unsigned short	op, op2, arg;

	static char    *gpopcodes[] = {
	    "GP1_EOCL", "GP1_USE_CONTEXT", "GP1_PR_VEC", "GP1_PR_ROP_NF",
	    "GP1_PR_ROP_FF", "GP1_PR_PGON_SOL", "GP1_SET_ZBUF",
	    "GP1_SET_HIDDEN_SURF", "GP1_SET_MAT_NUM", "GP1_MUL_POINT_FLT_2D",
	    "GP1_MUL_POINT_FLT_3D", "GP1_XF_PGON_FLT_3D",
	    "GP1_XF_PGON_FLT_2D", "GP1_corendcvec_3d", "GP1_cgivec",
	    "GP1_SET_CLIP_LIST",

	    "GP1_SET_FB_NUM", "GP1_SET_VWP_3D", "GP1_SET_VWP_2D",
	    "GP1_SET_ROP", "GP1_SET_CLIP_PLANES", "GP1_MUL_POINT_INT_2D",
	    "GP1_MUL_POINT_INT_3D", "GP1_SET_FB_PLANES", "GP1_SET_MAT_3D",
	    "GP1_xfvec_3d", "GP1_SET_MAT_OFFSET", "GP1_xfvec_2d",
	    "GP1_SET_COLOR", "GP1_SET_MAT_2D", "GP1_XF_PGON_INT_3D",
	    "GP1_COPY_MAT",

	    "GP1_MUL_MAT_2D", "GP1_MUL_MAT_3D", "GP1_GET_MAT_2D",
	    "GP1_GET_MAT_3D", "GP1_PROC_LINE_FLT_3D", "GP1_PROC_PGON_FLT_3D",
	    "GP1_PROC_PGON_FLT_2D", "GP1_SET_EF_TEX", "GP1_PR_LINE",
	    "GP1_PR_POLYLINE", "GP1_SET_LINE_TEX", "GP1_SET_LINE_WIDTH",
	    "GP1_CGI_LINE", "GP1_XF_LINE_FLT_2D", "GP1_XF_LINE_FLT_3D",
	    "GP1_XF_LINE_INT_3D",

	    "GP1_PR_PGON_TEX", "GP1_PR_ROP_TEX1", "GP1_PR_ROP_TEX8",
	    "GP1_SET_PGON_TEX_BLK", "GP1_SET_PGON_TEX",
	    "GP1_SET_PGON_TEX_ORG_SCR", "GP1_SET_PGON_TEX_ORG_XF_2D",
	    "GP1_SET_PGON_TEX_ORG_XF_3D", "GP1_SET_BKGND_COLOR",
	    "GP1_XF_LINE_INT_2D", "GP1_XF_PGON_INT_2D",
	    "GP1_PROC_PGON_INT_2D", "GP1_PROC_LINE_FLT_2D",
	    "GP1_PROC_LINE_INT_2D", "GP1_PROC_LINE_INT_3D",
	    "GP1_PROC_PGON_INT_3D",

	    "GP1_SET_PICK_ID", "GP1_SET_PICK_WINDOW", "GP1_GET_PICK",
	    "GP1_SET_PICK", "GP1_CLEAR_PICK", "GP1_XF_POINT_INT_2D",
	    "GP1_XF_POINT_INT_3D", "GP1_XF_POINT_FLT_2D",
	    "GP1_XF_POINT_FLT_3D", "GP1_CLEAR_CONTEXT", "GP1_SET_DEPTH_CUE",
	    "GP1_SET_DEPTH_CUE_COLORS", "GP1_SET_DEPTH_CUE_PARAMETERS",
	    "GP?", "GP?", "GP?",

	    "GP2_SET_RGB_COLOR", "GP2_PROC_PGON_FLT_3D_RGB",
	    "GP2_PROC_PGON_INT_3D_RGB", "GP2_XF_PGON_FLT_3D_RGB",
	    "GP2_XF_PGON_INT_3D_RGB", "GP2_SET_LIGHT",
	    "GP2_SET_LIGHT_MATRIX", "GP2_SET_REFLECTANCE", "?",
	    "GP2_SET_TRANSPARENCY", "GP2_SET_DITHER",
	    "GP2_SET_LIGHT_OPTIONS", "?", "?", "?", "?",

	    "?", "?", "?", "GP2_XF_SHADE_LINE_FLT_3D", "GP2_XF_RECT_INT_2D",
	    "GP2_XF_RECT_FLT_2D", "GP2_SET_TEXT_TYPE",
	    "GP2_SET_TEXT_PRECISION", "GP2_SET_TEXT_PATH", "GP2_SET_FONT",
	    "GP2_SET_TEXT_EXPANSION", "GP2_SET_TEXT_SPACING",

	    "GP2_SET_TEXT_MAP", "GP2_LOAD_FONT", "GP2_SET_TEXT_ATTRIBUTES",
	    "GP2_TEXT_INT_2D", "GP2_TEXT_FLT_2D", "GP2_TEXT_INT_3D",
	    "GP2_TEXT_FLT_3D", "GP2_SET_TEXT_MAT_NUM",
	 };

#define GPOP_MAX	      (sizeof(gpopcodes) / sizeof(char *))

	static char    *ptype[] = {"SHADE_CONSTANT", "SHADE_GOURAUD",
				   "SHADE_TEX", "INDEX_COLOR",
				   "RGB_COLOR_TRIPLE", "RGB_COLOR_PACK",
				   "VERTEX_NORMALS", "POLYGON_NORMAL" } ;


	if (pointer == NULL)
	  return;
	if (end_ptr == NULL)
	{
	  exit_at_eocl = 1;
	  end_ptr = pointer + 0xFFFF;
	  /* Actually we should print until end of shared memory */
	}
	else
	{
	  exit_at_eocl = 0;
	}

	ptr.sh = pointer;
	while (ptr.sh < end_ptr)	/* til buffer end */
	{
	  op = (unsigned short) *ptr.sh++;
	  op2 = op >> 8;
	  arg = op & 0xff;
	  op &= 0xff00;
	  if (op2 > GPOP_MAX)		/* illegal opcode */
	  {
	    printf("? %#4.4x\n", op);
	    continue;
	  }
	  printf("%s", gpopcodes[op2]);
	  switch (op)
	  {
	  default:			/* opcode, no args */
	    printf(" | %#x\n", arg);
	    break;

/*
 * EOCL | [ FREEBLKS ]
 * (int) bit vector of blocks
 */
	  case GP1_EOCL:		/* end it all */
	    if (arg == GP1_FREEBLKS)
	    {
	      GP1_GET_I(ptr.sh, n);
	      printf("\t| GP1_FREEBLKS, bv = %#8.8x\n", n);
	    }
	    else
	      printf("\n");

	    if (exit_at_eocl)
	      return;
	    else
	      break;


/*
 * PR_VEC | mask
 * (short) cg2 index
 * (short) op
 * (short) color
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) x0
 * (short) y0
 * (short) x1
 * (short) y1
 */
	  case GP1_PR_VEC:
	    {
	      short	      indx, rop, color, x, y, w, h, x0, y0, x1, y1;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      color = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      x0 = *ptr.sh++;
	      y0 = *ptr.sh++;
	      x1 = *ptr.sh++;
	      y1 = *ptr.sh++;
	      printf("\t| mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\tcolor=%#x\n", indx, rop, color);
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("x0,y0=(%d,%d)\tx1,y1=(%d,%d)\n", x0, y0, x1, y1);
	    }
	    break;


/*
 * PR_LINE | mask
 * (short) cg2 index
 * (short) op
 * (short) color
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) x0
 * (short) y0
 * (short) x1
 * (short) y1
 * (short) width
 * (short) pattern[0]
 *	...
 * (short) pattern[n]
 * (short) null
 * (short) offset	| -- not present if pattern is empty
 * (short) options	|
 */
	  case GP1_PR_LINE:
	    {
	      short	      indx, rop, color, x, y, w, h, x0, y0, x1, y1;
	      short	      width, offset;
	      unsigned short  options;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      color = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      x0 = *ptr.sh++;
	      y0 = *ptr.sh++;
	      x1 = *ptr.sh++;
	      y1 = *ptr.sh++;
	      width = *ptr.sh++;
	      printf("\t| mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\tcolor=%#x\twidth=%d\n",
		     indx, rop, color, width);
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("x0,y0=(%d,%d)\tx1,y1=(%d,%d)\n", x0, y0, x1, y1);
	      if ((x = *ptr.sh++) != 0)
	      {
		do
		{
		  printf("%d ", x);
		  x = *ptr.sh++;
		} while (x != 0);
		putchar('\n');
		offset = *ptr.sh++;
		options = *ptr.sh++;
		printf("offset=%d\toptions=%#4.4x\n", offset, options);
	      }
	    }
	    break;


/*
 * PR_POLYLINE | mask
 * (short) cg2 index
 * (short) op
 * (short) color
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) dx
 * (short) dy
 * (short) width
 * (short) pattern[0]
 *	...
 * (short) pattern[n]
 * (short) null
 * (short) offset	| -- not present if pattern is empty
 * (short) options	|
 * (short) x0
 * (short) y0
 *	...
 * (short) xn
 * (short) yn
 */
	  case GP1_PR_POLYLINE:
	    {
	      short	      indx, rop, color, x, y, w, h, dx, dy;
	      short	      width, offset;
	      unsigned short  options;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      color = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      width = *ptr.sh++;
	      printf("\t| mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\tcolor=%#x\twidth=%d\n",
		     indx, rop, color, width);
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("dx,dy=(%d,%d)\n", dx, dy);
	      if ((x = *ptr.sh++) != 0)
	      {
		do
		{
		  printf("%d ", x);
		  x = *ptr.sh++;
		} while (x != 0);
		putchar('\n');
		offset = *ptr.sh++;
		options = *ptr.sh++;
		printf("offset=%d\toptions=%#4.4x\n", offset, options);
	      }
	      n = *ptr.sh;
	      if (vpdbg > 1)
		for (i = 0; i < n; ++i)
		{
		  x = *ptr.sh++;
		  y = *ptr.sh++;
		  printf("%d\t%d\t%d\n", i, x, y);
		}
	      else
		ptr.sh += n * 2;
	    }
	    break;


/*
 * PR_ROP_FF | mask
 * (short) cg2 index
 * (short) op
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) dx
 * (short) dy
 * (short) dw
 * (short) dh
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) sx
 * (short) sy
 */
	  case GP1_PR_ROP_FF:
	    {
	      short	      indx, rop, x, y, w, h, dx, dy, dw, dh;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      dw = *ptr.sh++;
	      dh = *ptr.sh++;
	      printf("\t| mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\n", indx, rop);
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("dx,dy=(%d,%d)\tdw,dh=(%d,%d)\n", dx, dy, dw, dh);
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("sx,sy=(%d,%d)\n", dx, dy);
	    }
	    break;

/*
 * PR_PGON_SOL | mask
 * (short) cg2 index
 * (short) op
 * (short) x_left
 * (short) y_top
 * (short) width
 * (short) height
 * (short) dx
 * (short) dy
 * (short) nbnds
 * (short) npts[0]
 *	...
 * (short) npts[nbnds-1]
 * (short) x0
 * (short) y0
 *	...
 * (short) xn
 * (short) yn
 */
	  case GP1_PR_PGON_SOL:
	    {
	      short	      indx, rop, x, y, w, h, dx, dy;
	      int	      nb, ne, nt = 0, i;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      printf("\t| mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\n", indx, rop);
	      printf("x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      printf("dx,dy=(%d,%d)\n", dx, dy);
	      printf("%d bounds\n", nb = *ptr.sh++);
	      for (i = 1; i <= nb; ++i)
	      {
		printf("bound %d, %d edges\n", i, ne = *ptr.sh++);
		nt += ne;
	      }
	      i = 0;
	      if (vpdbg > 1)
		while (nt--)
		{
		  x = *ptr.sh++;
		  y = *ptr.sh++;
		  printf("%d\t%d\t%d\n", ++i, x, y);
		}
	      else
		ptr.sh += 2 * nt;
	    }
	    break;

/*
 * SET_ROP
 * (short) pixrect-style raster op
 */
	  case GP1_SET_ROP:
	    printf("\t%#x\n", *ptr.sh++);
	    break;

	  case GP2_SET_RGB_COLOR:
	    switch(arg)
	    {
	      case GP2_RGB_COLOR_TRIPLE:
		{
		  float	r,g,b ;
		  printf("\t| GP2_RGB_COLOR_TRIPLE");
		  GP1_GET_F(ptr.sh, r);
		  GP1_GET_F(ptr.sh, g);
		  GP1_GET_F(ptr.sh, b);
		  printf("\t%f,%f,%f\n",r,g,b) ;
		}
		break ;

	      case GP2_RGB_COLOR_PACK:
		{
		  int	r,g,b ;
		  printf("\t| GP2_RGB_COLOR_PACK");
		  GP1_GET_I(ptr.sh, r);
		  b = (r >> 16) & 0xff ;
		  g = (r >> 8) & 0xff ;
		  r &= 0xff ;
		  printf("\t%d,%d,%d\n",r,g,b) ;
		}
		break ;
	    }
	    break;

/*
 * SET_LINE_WIDTH width, 0
 */
	  case GP1_SET_LINE_WIDTH:
	    {
	      int	      width, opt;
	      width = *ptr.sh++, opt = *ptr.sh++;
	      printf("\t%d, %d\n", width, opt);
	    }
	    break;

/*
 * SET_LINE_TEX pattern options offset
 */
	  case GP1_SET_LINE_TEX:
	    {
	      int	      i;

	      i = 0;
	      while (n = *ptr.sh++)	/* another texture word? */
	      {
		if (--i < 0)		/* 8 columns? */
		{
		  printf("\n"); /* start another line */
		  i = 7;
		}
		printf("  %d", (u_short) n);
	      }
	      n = *ptr.sh++;
	      printf("\n  options = %d, offset = %d\n", n, *ptr.sh++);
	    }
	    break;

/*
 * SET_EF_TEX <16 word texture>
 */
	  case GP1_SET_EF_TEX:
	    {
	      int	      i, j;

	      printf("\n");
	      for (j = 0; ++j <= 4;)
	      {
		for (i = 0; ++i <= 4;)
		  printf("  %#4.4x", (u_short) * ptr.sh++);
		printf("\n");
	      }
	    }
	    break;

/*
 * SET_PGON_TEX_ORG_SCR sx, sy
 * SET_PGON_TEX_ORG_XF_2D sx, sy
 * SET_PGON_TEX_ORG_XF_3D sx, sy, sz
 * SET_PGON_TEX depth, width, height, pattern
 */
	  case GP1_SET_PGON_TEX_ORG_SCR:
	    n = *ptr.sh++;
	    printf(" %d, %d\n", n, *ptr.sh++);
	    break;

	  case GP1_SET_PGON_TEX_ORG_XF_2D:
	    {
	      float	      f1, f2;

	      GP1_GET_F(ptr.sh, f1);
	      GP1_GET_F(ptr.sh, f2);
	      printf(" %f, %f\n", f1, f2);
	    }
	    break;

	  case GP1_SET_PGON_TEX_ORG_XF_3D:
	    {
	      float	      f1, f2, f3;

	      GP1_GET_F(ptr.sh, f1);
	      GP1_GET_F(ptr.sh, f2);
	      GP1_GET_F(ptr.sh, f3);
	      printf(" %f, %f, %f\n", f1, f2, f3);
	    }
	    break;

	  case GP1_SET_PGON_TEX:
	    {
	      int	      i, s, d, w, h;

	      d = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      printf(" depth=%d, width=%d, height=%d", d, w, h);
	      s = (d == 1) ? h * ((w + 15) >> 4) : (h * w + 1) >> 1;
	      i = 0;
	      while (--s >= 0)	/* for each texture word */
	      {
		if (--i < 0)		/* 8 columns? */
		{
		  printf("\n\t");	/* start another line */
		  i = 7;
		}
		else
		  putchar(',');
		printf("%#4.4x", (u_short) * ptr.sh++);
	      }
	      printf("\n");
	    }
	    break;

/*
 * PR_ROP_NF | pixel planes mask
 * (short) frame buffer index
 * (short) raster op / color
 * clip rectangle (in device coordinates)
 *	(short) x origin of upper left corner
 *	(short) y origin of upper left corner
 *	(short) width in pixels
 *	(short) height in pixels
 * destination rectangle (with respect to clip rectangle)
 *	(short) x origin of upper left corner
 *	(short) y origin of upper left corner
 *	(short) width in pixels
 *	(short) height in pixels
 */
	  case GP1_PR_ROP_NF:
	    {
	      short	      indx, rop, x, y, w, h, dx, dy;
	      int	      nb, ne, nt = 0, i;
	      indx = *ptr.sh++;
	      rop = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      printf(" | mask=%#x\n", arg);
	      printf("cg2 index = %d\trop=%#x\n", indx, rop);
	      printf("clip: x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);

	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      w = *ptr.sh++;
	      h = *ptr.sh++;
	      printf("dst: x,y=(%d,%d)\tw,h=(%d,%d)\n", x, y, w, h);
	      break;
	    }

/*
 * MUL_MAT_2D / MUL_MAT_3D
 * (short) matrix A
 * (short) matrix B
 * (short) matrix C
 */
	  case GP1_MUL_MAT_2D:
	  case GP1_MUL_MAT_3D:
	    {
	      int	      a, b, c;

	      a = *ptr.sh++;
	      b = *ptr.sh++;
	      c = *ptr.sh++;
	      printf("\t%d, %d, %d\n", a, b, c);
	    }
	    break;

/*
 * SET_MAT_2D | matrix
 * (float) Mat[1,1]
 * (float) Mat[1,2]
 * (float) Mat[2,1]
 *	...
 * (float) Mat[3,2]
 */
	  case GP1_SET_MAT_2D:	/* matrix should follow */
	    printf(" | %d\n", arg);
mat2d:	    {
	      float	      m1, m2, m3, m4, m5, m6;

	      GP1_GET_F(ptr.sh, m1);
	      GP1_GET_F(ptr.sh, m2);
	      GP1_GET_F(ptr.sh, m3);
	      GP1_GET_F(ptr.sh, m4);
	      GP1_GET_F(ptr.sh, m5);
	      GP1_GET_F(ptr.sh, m6);

	      printf("\t%f\t%f\n\t%f\t%f\n\t%f\t%f\n", m1, m2, m3, m4, m5, m6);
	      break;
	    }

/*
 * SET_MAT_3D | matrix
 * (float) Mat[1,1]
 * (float) Mat[1,2]
 *	...
 * (float) Mat[4,4]
 */
	  case GP1_SET_MAT_3D:	/* matrix should follow */
	    printf(" | %d\n", arg);
mat3d:	    {
	      float	      m1, m2, m3, m4;
	      for (n = 4; n--;) /* 4 x 4 matrix */
	      {
		GP1_GET_F(ptr.sh, m1);
		GP1_GET_F(ptr.sh, m2);
		GP1_GET_F(ptr.sh, m3);
		GP1_GET_F(ptr.sh, m4);
		printf("\t%f\t%f\t%f\t%f\n", m1, m2, m3, m4);
	      }
	    }
	    break;

/*
 * GET_MAT_2D | matrix
 * (short) ready flag
 * (float) Mat[1,1]
 * ...
 * (float) Mat[3, 2]
 */
	  case GP1_GET_MAT_2D:
	    printf(" | %d, ready flag = %d\n", arg, *ptr.sh++);
	    goto mat2d;

/*
 * GET_MAT_3D | matrix
 * (short) ready flag
 * (float) Mat[1,1]
 * ...
 * (float) Mat[4,4]
 */
	  case GP1_GET_MAT_3D:
	    printf(" | %d, ready flag = %d\n", arg, *ptr.sh++);
	    goto mat3d;

/*
 * SET_VPW_2D
 * SET_VPW_3D
 * (float) X scale factor
 * (float) X origin of upper left
 * (float) Y scale factor
 * (float) Y origin of upper left
 */
	  case GP1_SET_VWP_2D:	/* set viewing transform */
	    {
	      float	      x, y, dx, dy;
	      GP1_GET_F(ptr.sh, x);
	      GP1_GET_F(ptr.sh, dx);
	      GP1_GET_F(ptr.sh, y);
	      GP1_GET_F(ptr.sh, dy);
	      printf("	%f,%f  %f,%f\n", x, dx, y, dy);
	    }
	    break;



	  case GP1_SET_VWP_3D:
	    {
	      float	      x, y, z, dx, dy, dz;
	      GP1_GET_F(ptr.sh, x);
	      GP1_GET_F(ptr.sh, dx);
	      GP1_GET_F(ptr.sh, y);
	      GP1_GET_F(ptr.sh, dy);
	      GP1_GET_F(ptr.sh, z);
	      GP1_GET_F(ptr.sh, dz);
	      printf("	%.2f,%.2f  %.2f,%.2f  %.2f,%.2f\n",
		     x, dx, y, dy, z, dz);
	    }
	    break;

/*
 * XFVEC_2D
 * (short) number of vectors (each vector is 2 endpoints)
 * (float) X coordinate of endpoint 1 |
 * (float) Y coordinate of endpoint 1 |------ vector 1
 * (float) X coordinate of endpoint 2 |
 * (float) Y coordinate of endpoint 2 |
 *	...
 * (float) X coordinate of endpoint 2n - 1 |
 * (float) Y coordinate of endpoint 2n - 1 |------- vector n
 * (float) X coordinate of endpoint 2n	   |
 * (float) Y coordinate of endpoint 2n	   |
 */
	  case GP1_XFVEC_2D:		/* vector list */
	    {
	      int	      i;
	      float	      x1, y1, x2, y2;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
	      {
		GP1_GET_I(ptr.sh, x1);
		GP1_GET_I(ptr.sh, y1);
		GP1_GET_I(ptr.sh, x2);
		GP1_GET_I(ptr.sh, y2);
		if (vpdbg > 1)
		  printf("%d\t%f\t%f\n%f\t%f\n", ++i, x1, y1, x2, y2);
	      }
	    }
	    break;

/*
 * XFVEC_3D
 * (short) number of vectors (each vector is 2 endpoints)
 * (float) X coordinate of endpoint 1 |
 * (float) Y coordinate of endpoint 1 |
 * (float) Z coordinate of endpoint 1 |------- vector 1
 * (float) X coordinate of endpoint 2 |
 * (float) Y coordinate of endpoint 2 |
 * (float) Z coordinate of endpoint 2 |
 *	...
 * (float) X coordinate of endpoint 2n - 1 |
 * (float) Y coordinate of endpoint 2n - 1 |
 * (float) Z coordinate of endpoint 2n - 1 |------- vector n
 * (float) X coordinate of endpoint 2n	   |
 * (float) Y coordinate of endpoint 2n	   |
 * (float) Z coordinate of endpoint 2n	   |
 */
	  case GP1_XFVEC_3D:		/* vector list */
	    {
	      int	      i;
	      float	      x1, y1, z1, x2, y2, z2;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
	      {
		GP1_GET_F(ptr.sh, x1);
		GP1_GET_F(ptr.sh, y1);
		GP1_GET_F(ptr.sh, z1);
		GP1_GET_F(ptr.sh, x2);
		GP1_GET_F(ptr.sh, y2);
		GP1_GET_F(ptr.sh, z2);
		if (vpdbg > 1)
		  printf("%d\t%f\t%f\t%f\n\t%f\t%f\t%f\n",
			 ++i, x1, y1, z1, x2, y2, z2);
	      }
	    }
	    break;

/*
 * XF_LINE_FLT_3D
 * (short) move/draw flag, END FLAG CLEAR
 * (float) X coordinate of vector 1
 * (float) Y coordinate of vector 1
 * (float) Z coordinate of vector 1
 *	...
 * (short) move/draw flag, END FLAG SET
 * (float) X coordinate of endpoint N
 * (float) Y coordinate of endpoint N
 * (float) Z coordinate of endpoint N
 */
	  case GP1_XF_LINE_FLT_3D:
	    {
	      int	      i, n;
	      float	      x, y, z;

	      printf("\n");
	      i = 0;
	      do
	      {
		n = *ptr.sh++;
		GP1_GET_F(ptr.sh, x);
		GP1_GET_F(ptr.sh, y);
		GP1_GET_F(ptr.sh, z);
		if (vpdbg > 1)
		  printf("%d\t%s\t%f\t%f\t%f\n", ++i,
			 (n & GP_MOVE_FLAG) ? "move" : "draw", x, y, z);
	      }
	      while (!(n & GP_END_FLAG)	 &&  ptr.sh < end_ptr) ;
	    }
	    break;
/*
 * XF_LINE_FLT_2D
 * (short) move/draw flag, END FLAG CLEAR
 * (float) X coordinate of vector 1
 * (float) Y coordinate of vector 1
 *	...
 * (short) move/draw flag, END FLAG SET
 * (float) X coordinate of endpoint N
 * (float) Y coordinate of endpoint N
 */
	  case GP1_XF_LINE_FLT_2D:
	    {
	      int	      i, n;
	      float	      x, y;

	      printf("\n");
	      i = 0;
	      do
	      {
		n = *ptr.sh++;
		GP1_GET_F(ptr.sh, x);
		GP1_GET_F(ptr.sh, y);
		if (vpdbg > 1)
		  printf("%d\t%s\t%f\t%f\n", ++i,
			 (n & GP_MOVE_FLAG) ? "move" : "draw", x, y);
	      }
	      while (!(n & GP_END_FLAG)	 &&  ptr.sh < end_ptr) ;
	    }
	    break;

/*
 * XF_LINE_INT_3D
 * (short) move/draw flag, END FLAG CLEAR
 * (int) X coordinate of vector 1
 * (int) Y coordinate of vector 1
 * (int) Z coordinate of vector 1
 *	...
 * (short) move/draw flag, END FLAG SET
 * (int) X coordinate of endpoint N
 * (int) Y coordinate of endpoint N
 * (int) Z coordinate of endpoint N
 */
	  case GP1_XF_LINE_INT_3D:
	    {
	      int	      i, n;
	      int	      x, y, z;

	      printf("\n");
	      i = 0;
	      do
	      {
		n = *ptr.sh++;
		GP1_GET_I(ptr.sh, x);
		GP1_GET_I(ptr.sh, y);
		GP1_GET_I(ptr.sh, z);
		if (vpdbg > 1)
		  printf("%d\t%s\t%d\t%d\t%d\n", ++i,
			 (n & GP_MOVE_FLAG) ? "move" : "draw", x, y, z);
	      }
	      while (!(n & GP_END_FLAG)	 &&  ptr.sh < end_ptr) ;
	    }
	    break;
/*
 * XF_LINE_INT_2D
 * (short) move/draw flag, END FLAG CLEAR
 * (int) X coordinate of vector 1
 * (int) Y coordinate of vector 1
 *	...
 * (short) move/draw flag, END FLAG SET
 * (int) X coordinate of endpoint N
 * (int) Y coordinate of endpoint N
 */
	  case GP1_XF_LINE_INT_2D:
	    {
	      int	      i, n;
	      int	      x, y;

	      printf("\n");
	      i = 0;
	      do
	      {
		n = *ptr.sh++;
		GP1_GET_I(ptr.sh, x);
		GP1_GET_I(ptr.sh, y);
		if (vpdbg > 1)
		  printf("%d\t%s\t%d\t%d\n", ++i,
			 (n & GP_MOVE_FLAG) ? "move" : "draw", x, y);
	      }
	      while (!(n & GP_END_FLAG)	 &&  ptr.sh < end_ptr) ;
	    }
	    break;

/*
 * CORENDCVEC_3D
 * (short) number of vectors (each vector is 2 endpoints)
 * (int) X coordinate of endpoint 1 |
 * (int) Y coordinate of endpoint 1 |
 * (int) Z coordinate of endpoint 1 |------- vector 1
 * (int) X coordinate of endpoint 2 |
 * (int) Y coordinate of endpoint 2 |
 * (int) Z coordinate of endpoint 2 |
 *	...
 * (int) X coordinate of endpoint 2n - 1 |
 * (int) Y coordinate of endpoint 2n - 1 |
 * (int) Z coordinate of endpoint 2n - 1 |------- vector n
 * (int) X coordinate of endpoint 2n	 |
 * (int) Y coordinate of endpoint 2n	 |
 * (int) Z coordinate of endpoint 2n	 |
 */
	  case GP1_CORENDCVEC_3D:	/* vector list */
	    {
	      int	      i;
	      int	      x1, y1, z1, x2, y2, z2;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
	      {
		GP1_GET_I(ptr.sh, x1);
		GP1_GET_I(ptr.sh, y1);
		GP1_GET_I(ptr.sh, z1);
		GP1_GET_I(ptr.sh, x2);
		GP1_GET_I(ptr.sh, y2);
		GP1_GET_I(ptr.sh, z2);
		if (vpdbg > 1)
		  printf("%d\t%d\t%d\t%d\n\t%d\t%d\t%d\n",
			 ++i, x1, y1, z1, x2, y2, z2);
	      }
	      break;
	    }

/*
 * CGIVEC
 * (short) number of vectors (each vector is 2 endpoints)
 * (int) X coordinate of endpoint 1 |
 * (int) Y coordinate of endpoint 1 |------ vector 1
 * (int) X coordinate of endpoint 2 |
 * (int) Y coordinate of endpoint 2 |
 *	...
 * (int) X coordinate of endpoint 2n - 1 |
 * (int) Y coordinate of endpoint 2n - 1 |------- vector n
 * (int) X coordinate of endpoint 2n	 |
 * (int) Y coordinate of endpoint 2n	 |
 */
	  case GP1_CGIVEC:		/* vector list */
	    {
	      int	      i;
	      int	      x1, y1, x2, y2;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
	      {
		GP1_GET_I(ptr.sh, x1);
		GP1_GET_I(ptr.sh, y1);
		GP1_GET_I(ptr.sh, x2);
		GP1_GET_I(ptr.sh, y2);
		if (vpdbg > 1)
		  printf("%d\t%d\t%d\n\t%d\t%d\n", ++i, x1, y1, x2, y2);
	      }
	      break;
	    }

/*
 * MUL_POINT_FLT_2D
 * (short) number of points
 * (float) X coordinate of point 1
 * (float) Y coordinate of point 1
 * (short) done flag
 *	...
 * (float) X coordinate of endpoint N
 * (float) Y coordinate of endpoint N
 * (short) done flag
 */
	  case GP1_MUL_POINT_FLT_2D:	/* transform a point list */
	    {
	      int	      i, n2, done;
	      float	      x, y;

	      printf("\t%d points\n", n = *ptr.sh++);
	      i = 0;
	      n2 = n;
	      if (vpdbg <= 1 && n2 > 5)
		n2 = 5;
	      n -= n2;
	      while (--n2 >= 0) /* print points */
	      {
		GP1_GET_F(ptr.sh, x);
		GP1_GET_F(ptr.sh, y);
		done = *ptr.sh++;
		printf("%d\t%f\t%f\t%d\n", ++i, x, y, done);
	      }
	      if (n > 0)
	      {
		printf("\t...\n");
		ptr.fl += 2 * n;
		ptr.sh += n;
	      }
	    }
	    break;

/*
 * MUL_POINT_FLT_3D
 * (short) number of points
 * (float) X coordinate of point 1
 * (float) Y coordinate of point 1
 * (float) Z coordinate of point 1
 * (float) W coordinate of point 1
 * (short) done flag
 *	...
 * (float) X coordinate of endpoint N
 * (float) Y coordinate of endpoint N
 * (float) Z coordinate of endpoint N
 * (float) W coordinate of endpoint N
 * (short) done flag
 */
	  case GP1_MUL_POINT_FLT_3D:	/* transform a point list */
	    {
	      int	      i, n2, done;
	      float	      x, y, z, w;

	      printf("\t%d points\n", n = *ptr.sh++);
	      i = 0;
	      n2 = n;
	      if (vpdbg <= 1 && n2 > 5)
		n2 = 5;
	      n -= n2;
	      while (--n2 >= 0) /* print points */
	      {
		GP1_GET_F(ptr.sh, x);
		GP1_GET_F(ptr.sh, y);
		GP1_GET_F(ptr.sh, z);
		GP1_GET_F(ptr.sh, w);
		done = *ptr.sh++;
		printf("%d\t%f\t%f\t%f\t%f\t%d\n", ++i, x, y, z, w, done);
	      }
	      if (n)
	      {
		printf("\t...\n");
		ptr.fl += 4 * n;
		ptr.sh += n;
	      }
	    }
	    break;

/*
 * MUL_POINT_INT_3D
 * (short) number of points
 * (int) X coordinate of point 1
 * (int) Y coordinate of point 1
 * (int) Z coordinate of point 1
 * (int) W coordinate of point 1
 * (short) done flag
 *	...
 * (int) X coordinate of endpoint N
 * (int) Y coordinate of endpoint N
 * (int) Z coordinate of endpoint N
 * (int) W coordinate of endpoint N
 * (short) done flag
 */
	  case GP1_MUL_POINT_INT_3D:	/* transform a point list */
	    {
	      int	      i, n2, done;
	      int	      x, y, z, w;

	      printf("\t%d points\n", n = *ptr.sh++);
	      i = 0;
	      n2 = n;
	      if (vpdbg <= 1 && n2 > 5)
		n2 = 5;
	      n -= n2;
	      while (--n2 >= 0) /* print points */
	      {
		GP1_GET_I(ptr.sh, x);
		GP1_GET_I(ptr.sh, y);
		GP1_GET_I(ptr.sh, z);
		GP1_GET_I(ptr.sh, w);
		done = *ptr.sh++;
		printf("%d\t%d\t%d\t%d\t%d\t%d\n", ++i, x, y, z, w, done);
	      }
	      if (n)
	      {
		printf("\t...\n");
		ptr.in += 4 * n;
		ptr.sh += n;
	      }
	      break;
	    }

/*
 * MUL_POINT_INT_2D
 * (short) number of points
 * (int) X coordinate of point 1
 * (int) Y coordinate of point 1
 * (short) done flag
 *	...
 * (int) X coordinate of endpoint N
 * (int) Y coordinate of endpoint N
 * (short) done flag
 */
	  case GP1_MUL_POINT_INT_2D:	/* transform a point list */
	    {
	      int	      i, n2, done;
	      int	      x, y;

	      printf("\t%d points\n", n = *ptr.sh++);
	      i = 0;
	      n2 = n;
	      if (vpdbg <= 1 && n2 > 5)
		n2 = 5;
	      n -= n2;
	      while (--n2 >= 0) /* print points */
	      {
		GP1_GET_I(ptr.sh, x);
		GP1_GET_I(ptr.sh, y);
		done = *ptr.sh++;
		printf("%d\t%d\t%d\t%d\n", ++i, x, y, done);
	      }
	      if (n)
	      {
		printf("\t...\n");
		ptr.in += 2 * n;
		ptr.sh += n;
	      }
	    }
	    break;

/*
 * PROC_LINE_FLT_3D
 * (short) number of vectors (each vector is 2 endpoints)
 * (short) clip flag		      |
 * (float) X coordinate of endpoint 1 |
 * (float) Y coordinate of endpoint 1 |
 * (float) Z coordinate of endpoint 1 |------- vector 1
 * (float) X coordinate of endpoint 2 |
 * (float) Y coordinate of endpoint 2 |
 * (float) Z coordinate of endpoint 2 |
 * (short) done flag		      |
 *	...
 * (short) clip flag			   |
 * (float) X coordinate of endpoint 2n - 1 |
 * (float) Y coordinate of endpoint 2n - 1 |
 * (float) Z coordinate of endpoint 2n - 1 |------- vector n
 * (float) X coordinate of endpoint 2n	   |
 * (float) Y coordinate of endpoint 2n	   |
 * (float) Z coordinate of endpoint 2n	   |
 * (short) done flag			   |
 */
	  case GP1_PROC_LINE_FLT_3D:	/* transform a vector list */

	      /* this is tricky, the input is floating-point, but the
		 output is integer.  The format depends on whether or
		 not the 'done' flag is set.  We kludge and let
		 PROC_LINE_INT_3D handle this as a special case */

/*
 * PROC_LINE_INT_3D
 * (short) number of vectors (each vector is 2 endpoints)
 * (short) clip flag		    |
 * (int) X coordinate of endpoint 1 |
 * (int) Y coordinate of endpoint 1 |
 * (int) Z coordinate of endpoint 1 |------- vector 1
 * (int) X coordinate of endpoint 2 |
 * (int) Y coordinate of endpoint 2 |
 * (int) Z coordinate of endpoint 2 |
 * (short) done flag		    |
 *	...
 * (short) clip flag			 |
 * (int) X coordinate of endpoint 2n - 1 |
 * (int) Y coordinate of endpoint 2n - 1 |
 * (int) Z coordinate of endpoint 2n - 1 |------- vector n
 * (int) X coordinate of endpoint 2n	 |
 * (int) Y coordinate of endpoint 2n	 |
 * (int) Z coordinate of endpoint 2n	 |
 * (short) done flag			 |
 */
	  case GP1_PROC_LINE_INT_3D:	/* transform a vector list */
	    {
	      int	      i, clip, done;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
		if (op == GP1_PROC_LINE_INT_3D || *(ptr.sh + 13) == 0)
		{
		  int		  x1, y1, z1, x2, y2, z2;
		  clip = *ptr.sh++;
		  GP1_GET_I(ptr.sh, x1);
		  GP1_GET_I(ptr.sh, y1);
		  GP1_GET_I(ptr.sh, z1);
		  GP1_GET_I(ptr.sh, x2);
		  GP1_GET_I(ptr.sh, y2);
		  GP1_GET_I(ptr.sh, z2);
		  done = *ptr.sh++;
		  printf("%3d  %4d  %4d	 %4d  %4d  %4d	%4d  %#x  %d\n",
			 ++i, x1, y1, z1, x2, y2, z2, clip, done);
		}
		else
		{
		  float		  x1, y1, z1, x2, y2, z2;
		  clip = *ptr.sh++;
		  GP1_GET_F(ptr.sh, x1);
		  GP1_GET_F(ptr.sh, y1);
		  GP1_GET_F(ptr.sh, z1);
		  GP1_GET_F(ptr.sh, x2);
		  GP1_GET_F(ptr.sh, y2);
		  GP1_GET_F(ptr.sh, z2);
		  done = *ptr.sh++;
		  printf(
		    "%3d  %- 8g	 %- 8g	%- 8g  %- 8g  %- 8g  %- 8g  %#x	 %d\n",
		     ++i, x1, y1, z1, x2, y2, z2, clip, done);
		}
	    }
	    break;

/*
 * PROC_LINE_FLT_2D
 * (short) number of vectors (each vector is 2 endpoints)
 * (short) clip flag		      |
 * (float) X coordinate of endpoint 1 |
 * (float) Y coordinate of endpoint 1 |
 * (float) X coordinate of endpoint 2 |
 * (float) Y coordinate of endpoint 2 |
 * (short) done flag		      |
 *	...
 * (short) clip flag			   |
 * (float) X coordinate of endpoint 2n - 1 |
 * (float) Y coordinate of endpoint 2n - 1 |
 * (float) X coordinate of endpoint 2n	   |
 * (float) Y coordinate of endpoint 2n	   |
 * (short) done flag			   |
 */
	  case GP1_PROC_LINE_FLT_2D:	/* transform a vector list */
	      /* this is tricky, the input is floating-point, but the
		 output is integer.  The format depends on whether or
		 not the 'done' flag is set.  We kludge and let
		 PROC_LINE_INT_2D handle this as a special case */
/*
 * PROC_LINE_INT_2D
 * (short) number of vectors (each vector is 2 endpoints)
 * (short) clip flag		    |
 * (int) X coordinate of endpoint 1 |
 * (int) Y coordinate of endpoint 1 |
 * (int) X coordinate of endpoint 2 |
 * (int) Y coordinate of endpoint 2 |
 * (short) done flag		    |
 *	...
 * (short) clip flag			 |
 * (int) X coordinate of endpoint 2n - 1 |
 * (int) Y coordinate of endpoint 2n - 1 |
 * (int) X coordinate of endpoint 2n	 |
 * (int) Y coordinate of endpoint 2n	 |
 * (short) done flag			 |
 */
	  case GP1_PROC_LINE_INT_2D:	/* transform a vector list */
	    {
	      int	      i, clip, done;

	      printf("\t%d vectors\n", n = *ptr.sh++);
	      i = 0;
	      while (--n >= 0)	/* print vector endpoints */
		if (op == GP1_PROC_LINE_INT_2D || *(ptr.sh + 9) == 0)
		{
		  int	      x1, y1, x2, y2;
		  clip = *ptr.sh++;
		  GP1_GET_I(ptr.sh, x1);
		  GP1_GET_I(ptr.sh, y1);
		  GP1_GET_I(ptr.sh, x2);
		  GP1_GET_I(ptr.sh, y2);
		  done = *ptr.sh++;
		  printf("%3d  %4d  %4d	 %4d  %4d  %#x	%d\n",
			 ++i, x1, y1, x2, y2, clip, done);
		}
		else
		{
		  float	      x1, y1, x2, y2;
		  clip = *ptr.sh++;
		  GP1_GET_F(ptr.sh, x1);
		  GP1_GET_F(ptr.sh, y1);
		  GP1_GET_F(ptr.sh, x2);
		  GP1_GET_F(ptr.sh, y2);
		  done = *ptr.sh++;
		  printf("%3d  %- 8g  %- 8g  %- 8g  %- 8g  %#x	%d\n",
			 ++i, x1, y1, x2, y2, clip, done);
		}
	    }
	    break;

/*
 * GP1_PROC_PGON_INT_3D | [ SHADE_CONSTANT, SHADE_GOURAUD or SHADE_TEX ]
 * (short) number of edges
 * (short) number of vertices for edge 1
 * (short) number of vertices for edge 2
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 * (int) Z coordinate of vertex 1 |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...			  |---- edge 1
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 * (int) Z coordinate of vertex n |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 * (int) Z coordinate of vertex 1 |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...			  |---- edge 2
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 * (int) Z coordinate of vertex n |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 * (short) maxshorts
 * (short) GP1_EOCL
 */

	case GP1_PROC_PGON_INT_2D:
	case GP1_PROC_PGON_INT_3D:
	case GP1_PROC_PGON_FLT_2D:
	case GP1_PROC_PGON_FLT_3D:
	    {
		int	dflag = (op == GP1_PROC_PGON_INT_3D) ||
				(op == GP1_PROC_PGON_FLT_3D) ;
		int	fflag = (op == GP1_PROC_PGON_FLT_2D) ||
				(op == GP1_PROC_PGON_FLT_3D) ;
		printf(" | %s\n", ptype[arg]);
		show_poly(arg, dflag, fflag) ;
		printf("ready flag = %d\n", n = *ptr.sh++) ;
		printf("%4.4x\n", *ptr.sh++) ;
		if(n == 0  &&  ptr.sh < end_ptr)
		{
		  puts("processed polygon:") ;
		  show_poly(arg, dflag, 0) ;
		}
	    }
	    break ;


#ifdef	COMMENT
	case GP1_PROC_PGON_INT_3D:
	    printf("\tSHADE_%s\n", ptype[arg]);
	    show_poly(arg, 1, 0) ;
	    printf("ready flag = %d\n", n = *ptr.sh++) ;
	    printf("%4.4x\n", *ptr.sh++) ;
	    if(n == 0  &&  ptr.sh < end_ptr)
	    {
	      puts("processed polygon:") ;
	      show_poly(arg, 1, 0) ;
	    }
	    break ;




	case GP1_PROC_PGON_FLT_2D:
	    printf("\tSHADE_%s\n", ptype[arg]);
	    show_poly(arg, 0, 1) ;
	    printf("ready flag = %d\n", n = *ptr.sh++) ;
	    printf("%4.4x\n", *ptr.sh++) ;
	    if(n == 0  &&  ptr.sh < end_ptr)
	    {
	      puts("processed polygon:") ;
	      show_poly(arg, 0, 0) ;
	    }
	    break ;


	case GP1_PROC_PGON_FLT_3D:
	    printf("\tSHADE_%s\n", ptype[arg]);
	    show_poly(arg, 1, 1) ;
	    printf("ready flag = %d\n", n = *ptr.sh++) ;
	    printf("%4.4x\n", *ptr.sh++) ;
	    if(n == 0  &&  ptr.sh < end_ptr)
	    {
	      puts("processed polygon:") ;
	      show_poly(arg, 1, 0) ;
	    }
	    break ;
#endif	COMMENT




/*
 * XF_PGON_INT_3D | [ SHADE_CONSTANT, SHADE_GOURAUD or SHADE_TEX ]
 * (short) number of edges
 * (short) number of vertices for edge 1
 * (short) number of vertices for edge 2
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 * (int) Z coordinate of vertex 1 |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...			  |---- edge 1
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 * (int) Z coordinate of vertex n |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 * (int) Z coordinate of vertex 1 |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 *	...			  |---- edge 2
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 * (int) Z coordinate of vertex n |
 * (short) color | G shaded only  |
 * (short) 0	 |		  |
 */
	  case GP1_XF_PGON_INT_3D:	/* 3D polygon */
	    printf("\t%s\n", ptype[arg]);
	    show_poly(arg, 1, 0) ;
	    break;

/*
 * XF_PGON_INT_2D | [ SHADE_CONSTANT or SHADE_TEX ]
 * (short) number of edges
 * (short) number of vertices for edge 1
 * (short) number of vertices for edge 2
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 *	...			  |---- edge 1
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 *	...
 * (int) X coordinate of vertex 1 |
 * (int) Y coordinate of vertex 1 |
 *	...			  |---- edge 2
 * (int) X coordinate of vertex n |
 * (int) Y coordinate of vertex n |
 */
	  case GP1_XF_PGON_INT_2D:	/* 2D polygon */
	    printf("\t%s\n", ptype[arg]);
	    show_poly(arg, 0, 0) ;
	    break;

/*
 * XF_PGON_FLT_3D | [ SHADE_CONSTANT, SHADE_GOURAUD or SHADE_TEX ]
 * (short) number of edges
 * (short) number of vertices for edge 1
 * (short) number of vertices for edge 2
 *	...
 * (float) X coordinate of vertex 1 |
 * (float) Y coordinate of vertex 1 |
 * (float) Z coordinate of vertex 1 |
 * (short) color | G shaded only    |
 * (short) 0	 |		    |
 *	...			    |---- edge 1
 * (float) X coordinate of vertex n |
 * (float) Y coordinate of vertex n |
 * (float) Z coordinate of vertex n |
 * (short) color | G shaded only    |
 * (short) 0	 |		    |
 *	...
 * (float) X coordinate of vertex 1 |
 * (float) Y coordinate of vertex 1 |
 * (float) Z coordinate of vertex 1 |
 * (short) color | G shaded only    |
 * (short) 0	 |		    |
 *	...			    |---- edge 2
 * (float) X coordinate of vertex n |
 * (float) Y coordinate of vertex n |
 * (float) Z coordinate of vertex n |
 * (short) color | G shaded only    |
 * (short) 0	 |		    |
 */
	  case GP1_XF_PGON_FLT_3D:	/* 3D polygon */
	    printf("\t%s\n", ptype[arg]);
	    show_poly(arg, 1, 1) ;
	    break;

/*
 * XF_PGON_FLT_2D
 * (short) number of edges
 * (short) number of vertices for edge 1
 * (short) number of vertices for edge 2
 *	...
 * (float) X coordinate of vertex 1 |
 * (float) Y coordinate of vertex 1 |
 *	...			    |---- edge 1
 * (float) X coordinate of vertex n |
 * (float) Y coordinate of vertex n |
 *	...
 * (float) X coordinate of vertex 1 |
 * (float) Y coordinate of vertex 1 |
 *	...			    |---- edge 2
 * (float) X coordinate of vertex n |
 * (float) Y coordinate of vertex n |
 */
	  case GP1_XF_PGON_FLT_2D:	/* 2D polygon */
	    printf("\t%s\n", ptype[arg]);
	    show_poly(arg, 0, 1) ;
	    break;

	  case GP2_XF_PGON_INT_3D_RGB:	/* 3D polygon */
	    printf("\t%s\n", ptype[arg+3]);
	    show_poly(arg+3, 1, 0) ;
	    break;

	  case GP2_XF_PGON_FLT_3D_RGB:	/* 3D polygon */
	    printf("\t%s\n", ptype[arg+3]);
	    show_poly(arg+3, 1, 1) ;
	    break;

/*
 * SET_CLIP_LIST
 * (short) # of rectangles
 * (short) X position of upper left |
 * (short) Y position of upper left |----- rectangle 1
 * (short) X dimension		    |
 * (short) Y dimension		    |
 * ...
 */
	  case GP1_SET_CLIP_LIST:	/* clip list */
	    {
	      int	      i;

	      i = 0;
	      n = *ptr.sh++;		/* how many rectangles */
	      printf("\t%d\n", n);
	      while (--n >= 0)
	      {
		int		x, y, dx, dy;

		x = *ptr.sh++;
		y = *ptr.sh++;
		dx = *ptr.sh++;
		dy = *ptr.sh++;
		printf("%d\t%d,%d  %d,%d\n", ++i, x, y, dx, dy);
	      }
	    }
	    break;
/*
 * SET_ZBUF
 * (short) value to store in Z buffer
 * (short) X position of upper left
 * (short) Y position of upper left
 * (short) X dimension
 * (short) Y dimension
 */
	  case GP1_SET_ZBUF:		/* Z buffer */
	    {
	      int	      x, y, dx, dy;

	      n = *ptr.sh++;
	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      printf("\t%d  %d,%d  %d,%d\n", n, x, y, dx, dy);
	    }
	    break;

#ifdef GP1_SET_PICK_ID
/*
 * SET_PICK_ID | 0,1
 * (int) new pick id
 */
	  case GP1_SET_PICK_ID:
	    {
	      int	      a;
	      GP1_GET_I(ptr.sh, a);
	      printf(" | %d\t%d\n", arg, a) ;
	    }
	    break;
#endif GP1_SET_PICK_ID

#ifdef GP1_SET_PICK_WINDOW
/*
 * SET_PICK_WINDOW
 * (short) x0,y0
 * (short) dx,dy
 */
	  case GP1_SET_PICK_WINDOW:
	    {
	      int	      x, y, dx, dy;

	      x = *ptr.sh++;
	      y = *ptr.sh++;
	      dx = *ptr.sh++;
	      dy = *ptr.sh++;
	      printf("\t%d,%d,%d,%d\n", x, y, dx, dy);
	    }
	    break;
#endif GP1_SET_PICK_WINDOW

#ifdef GP1_GET_PICK
/*
 * GET_PICK
 * (short) done-flag
 * (short) hit-flag
 * (int) count of primitives since last clear_pick
 * (int) id0
 * (int) id1
 */
	  case GP1_GET_PICK:
	    {
	       int flag, hit, count, id0, id1, i=arg ;

	       flag = *ptr.sh++;
	       printf(" | %d, flag=%d\n", arg, flag) ;
	       while(--i >= 0)
	       {
		  hit = *ptr.sh++;
		  GP1_GET_I(ptr.sh, count);
		  GP1_GET_I(ptr.sh, id0);
		  GP1_GET_I(ptr.sh, id1);
		  printf("\thit=%d\tcount=%d\tid0=%d\tid1=%d\n",
			count,id0,id1) ;
	       }
	    }
	    break;
#endif GP1_GET_PICK

#ifdef GP1_SET_PICK
/*
 * SET_PICK | mode
 */
	  case GP1_SET_PICK:
	    {
	       static char *pikmode[] = {"OFF", "DRAW","NODRAW"} ;

	       printf(" | GP1_PICK_%s\n", pikmode[arg]) ;
	    }
	    break;
#endif GP1_SET_PICK

#ifdef	GP1_SET_MAT_OFFSET
/*
 * SET_MAT_OFFSET
 * (short) address
 * (short) numblks
 */
	  case GP1_SET_MAT_OFFSET:
	    {
	      short addr, numblks ;
	      addr = *ptr.sh++ ;
	      numblks = *ptr.sh++ ;
	      printf("\taddr=%d\tnumblks=%d\n",addr,numblks) ;
	    }
	   break ;
#endif	GP1_SET_MAT_OFFSET

#ifdef	GP1_COPY_MAT
/*
 * COPY_MAT
 * (short) src,dst
 */
	  case GP1_COPY_MAT:
	    {
	      short src,dst ;
	      src = *ptr.sh++ ;
	      dst = *ptr.sh++ ;
	      printf("\tsrc=%d\tdst=%d\n",src,dst) ;
	    }
	    break ;
#endif	GP1_COPY_MAT


#ifdef	GP1_XF_POINT_INT_2D
/*
 * XF_LINE_INT_2D, XF_LINE_FLT_2D, XF_LINE_INT_3D, XF_LINE_FLT_3D
 * (short) scale
 * (short) dx,dy
 * (short) type (0=line, 1=polygon, 2=circle, 3=filled circle)
 *
 * type GP1_MARKER_LINE:
 *   (short) npts
 *   (short) move/draw flag
 *   (short) X coordinate of endpoint 1
 *   (short) Y coordinate of endpoint 1
 *	:
 *   (short) move/draw flag
 *   (short) X coordinate of endpoint N
 *   (short) Y coordinate of endpoint N
 *
 * type GP1_MARKER_POLY:
 *   (short) number of edges
 *   (short) number of vertices for edge 1
 *   (short) number of vertices for edge 2
 *	...
 *   (short) X coordinate of vertex 1 |
 *   (short) Y coordinate of vertex 1 |
 *	...			      |---- edge 1
 *   (short) X coordinate of vertex n |
 *   (short) Y coordinate of vertex n |
 *	...
 *   (short) X coordinate of vertex 1 |
 *   (short) Y coordinate of vertex 1 |
 *	...			      |---- edge 2
 *   (short) X coordinate of vertex n |
 *   (short) Y coordinate of vertex n |
 *
 * type GP1_MARKER_CIRC, GP1_MARKER_FILL_CIRC:
 *   (short) radius
 *
 * (int/float) X coordinate of marker 1
 * (int/float) Y coordinate of marker 1
 * (int/float) [Z coordinate of marker 1]
 *	...
 * (int/float) X coordinate of marker N
 * (int/float) Y coordinate of marker N
 * (int/float) [Z coordinate of marker N]
 */
	  case GP1_XF_POINT_FLT_2D:
	  case GP1_XF_POINT_FLT_3D:
	  case GP1_XF_POINT_INT_2D:
	  case GP1_XF_POINT_INT_3D:
	    {
	      short scale,dx,dy,type,npts, n ;
	      int ix,iy,iz ;
	      float x,y,z ;
	      static char *tnames[] = {"LINE", "PGON", "CIRC","FILL_CIRC"} ;

	      scale = *ptr.sh++ ;
	      dx = *ptr.sh++ ;
	      dy = *ptr.sh++ ;
	      type = *ptr.sh++ ;
	      printf("\tscale=%d\tdx,dy=%d,%d\ttype=GP1_MARKER_%s\n",
		scale, dx,dy, tnames[type]) ;
	      switch(type)
	      {
		case GP1_MARKER_LINE:
		  {
		    short ndpts, mvlist ;

		    ndpts = *ptr.sh++ ;
		    printf("  %d points\n",ndpts) ;
		    for(i=1; i <= ndpts; ++i)
		    {
		      mvlist = *ptr.sh++ ;
		      ix = *ptr.sh++ ;
		      iy = *ptr.sh++ ;
		      printf("  %d\t%s\t%d\t%d\n",
			i, (mvlist & GP_MOVE_FLAG) ? "move" : "draw", ix,iy) ;
		    }
		  }
		  break ;

		case GP1_MARKER_POLY:
		  {
		    short nbnds, ndpts[MAX_BNDS] ;
		    int	i,j ;

		    nbnds = *ptr.sh++ ;
		    printf("  %d bounds\n",nbnds) ;
		    if( nbnds > MAX_BNDS )
		     nbnds = MAX_BNDS ;
		    for(i=0; i<nbnds; ++i)
		    {
		      ndpts[i] = *ptr.sh++ ;
		      printf("  bound %d, %d points\n",i,ndpts[i]) ;
		    }
		    for(i=1; i<=nbnds; ++i)
		    {
		      for(j=1; j <= ndpts[i]; ++j)
		      {
			ix = *ptr.sh++ ;
			iy = *ptr.sh++ ;
			printf("  %d\t%d\t%d\n", j, ix,iy) ;
		      }
		    }
		  }
		  break ;

		case GP1_MARKER_CIRC:
		case GP1_MARKER_FILL_CIRC:
		  printf("  radius=%d\n",*ptr.sh++) ;
		  break ;
	      }

	      npts = *ptr.sh++ ;
	      printf("  npts=%d\n",npts) ;
	      for(i=1; i<=npts; ++i)
		switch(op)
		{
		  case GP1_XF_POINT_FLT_2D:
		    GP1_GET_F(ptr.sh, x);
		    GP1_GET_F(ptr.sh, y);
		    printf("  %d\t%f\t%f\n", i, x,y) ;
		    break ;

		  case GP1_XF_POINT_FLT_3D:
		    GP1_GET_F(ptr.sh, x);
		    GP1_GET_F(ptr.sh, y);
		    GP1_GET_F(ptr.sh, z);
		    printf("  %d\t%f\t%f\t%f\n", i, x,y,z) ;
		    break ;

		  case GP1_XF_POINT_INT_2D:
		    GP1_GET_I(ptr.sh, ix);
		    GP1_GET_I(ptr.sh, iy);
		    printf("  %d\t%d\t%d\n", i, ix,iy) ;
		    break ;

		  case GP1_XF_POINT_INT_3D:
		    GP1_GET_I(ptr.sh, ix);
		    GP1_GET_I(ptr.sh, iy);
		    GP1_GET_I(ptr.sh, iz);
		    printf("  %d\t%d\t%d\t%d\n", i, ix,iy,iz) ;
		    break ;
		}
	    }
#endif	GP1_XF_POINT_INT_2D


	  }				/* switch */
	}				/* while */
}




/* show polygon.  "class" is:
 *
 * 0 = GP1_SHADE_CONSTANT
 * 1 = GP1_SHADE_GOURAUD
 * 2 = GP1_SHADE_TEX
 * 3 = GP2_INDEX_COLOR
 * 4 = GP2_RGB_COLOR_TRIPLE
 * 5 = GP2_RGB_COLOR_PACK
 * 6 = GP2_VERTEX_NORMALS
 * 7 = GP2_POLYGON_NORMAL
 */

show_poly(class, dflag, floatflag)
	int	class, dflag, floatflag ;
{
	int	i, j, nv = 0, nb, n;
	int	ix, iy, iz;
	float	x, y, z ;
	short	*bnd_ptr ;

	nb = *ptr.sh++;
	printf("%d bound(s)\n", nb);
	bnd_ptr = ptr.sh ;
	ptr.sh += nb ;
	for(i=0; i<nb; ++i)
	{
	  printf("Bound %d, %d edges\n", i, nv = *bnd_ptr++);
	  if(vpdbg > 1)
	  {
	    for(j=0; j<nv; ++j)
	    {
	      if(dflag)
	      {
		if(floatflag)
		{
		  GP1_GET_F(ptr.sh, x);
		  GP1_GET_F(ptr.sh, y);
		  GP1_GET_F(ptr.sh, z);
		  printf("%d\t%f\t%f\t%f", j, x, y, z);
		}
		else
		{
		  GP1_GET_I(ptr.sh, ix);
		  GP1_GET_I(ptr.sh, iy);
		  GP1_GET_I(ptr.sh, iz);
		  printf("%d\t%d\t%d\t%d", j, ix, iy, iz);
		}
		switch(class)
		{
		  case 0:	/* GP1_SHADE_CONSTANT */
		  case 2:	/* GP1_SHADE_GOURAUD */
		  case 3:	/* GP2_INDEX_COLOR */
		    break ;

		  case 1:	/* GP1_SHADE_GOURAUD */
		    n = *ptr.sh++;
		    printf("\t%d:%d", n, *ptr.sh++);
		    break ;

		  case 4:	/* GP2_RGB_COLOR_TRIPLE */
		    {
		      float r,g,b ;
		      GP1_GET_F(ptr.sh, r) ;
		      GP1_GET_F(ptr.sh, g) ;
		      GP1_GET_F(ptr.sh, b) ;
		      printf("\t%f:%f:%f", r,g,b);
		    }
		    break ;

		  case 5:	/* GP2_RGB_COLOR_PACK */
		    {
		      int r,g,b ;
		      GP1_GET_I(ptr.sh, r) ;
		      b = (r >> 16) & 0xff ;
		      g = (r >> 8) & 0xff ;
		      r &= 0xff ;
		      printf("\t%d:%d:%d", r,g,b) ;
		    }
		    break ;
		}
	      }
	      else
	      {
		if(floatflag)
		{
		  GP1_GET_F(ptr.sh, x);
		  GP1_GET_F(ptr.sh, y);
		  printf("%d\t%f\t%f", j, x, y);
		}
		else
		{
		  GP1_GET_I(ptr.sh, ix);
		  GP1_GET_I(ptr.sh, iy);
		  printf("%d\t%d\t%d", j, ix, iy);
		}
	      }
	      putchar('\n') ;
	    }
	  }
	  else
	  {
	    if(dflag)
	    {
	      switch(class)
	      {
		case 0:	/* GP1_SHADE_CONSTANT */
		case 2:	/* GP1_SHADE_TEX */
		case 3:	/* GP2_INDEX_COLOR */
		  ptr.sh += nv*3*(sizeof(float)/sizeof(short)) ;
		  break ;

		case 1:	/* GP1_SHADE_GOURAUD */
		case 5:	/* GP2_RGB_COLOR_PACK */
		  ptr.sh += nv*((3*sizeof(float)+sizeof(long))/sizeof(short)) ;
		  break ;

		case 4:	/* GP2_RGB_COLOR_TRIPLE */
		  ptr.sh += nv*6*(sizeof(float)/sizeof(short)) ;
		  break ;
	      }
	    }
	    else
	    {
	      ptr.sh += nv*2*sizeof(float)/sizeof(short) ;
	    }
	  }
	}
}
