/*	@(#)dev_pw.h 1.1 88/11/23 SMI	*/

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */


#ifndef	DEV_PW_DEFINED
#define	DEV_PW_DEFINED



typedef struct {
    float	x, y, z;
} Point3df;	/* a 3D floating-point point */

typedef struct {
    float	x, y;
} Point2df;	/* a 2D floating-point point */

typedef struct {
    int		x, y, z;
} Point3di;	/* a 3D integer point */

typedef struct {
    int		x, y;
} Point2di;	/* a 2D integer point */

typedef	struct {
    Point3di	p ;
    int		color ;
} Point3dic ;	/* a 3d integer point with color */

typedef	struct {
    Point3df	p ;
    int		color ;
} Point3dfc ;	/* a 3d floating-point point with color */

typedef float	Matrix3df[4][4];

typedef float	Matrix2df[3][2];


#define	POINT2(p,x0,y0)		(p.x=(x0), p.y=(y0), &p)
#define	POINT3(p,x0,y0,z0)	(p.x=(x0), p.y=(y0), p.z=(z0), &p)



#define PW_CLIP_LEFT	0x20
#define PW_CLIP_RIGHT	0x10
#define PW_CLIP_BOTTOM	0x8
#define PW_CLIP_TOP	0x4
#define PW_CLIP_HITHER	0x2
#define PW_CLIP_YON	0x1

#define PW_NOHIDDENSURF	0	/* for SET_HIDDENSURF */
#define PW_ZBHIDDENSURF	1

#define PW_SHADE_CONSTANT	0	/* for XF_POLYGON */
#define PW_SHADE_GOURAUD	1
#define PW_SHADE_TEX		2

typedef struct _PW 	*PW_handle;

/* malloc failed */
#define DEV_PW_ERR_NO_MEMORY		4




extern	PW_handle	Dev_pw_create();
extern	PW_handle	Dev_pw_create_pr();
extern	void		Dev_pw_destroy();
extern	void		Dev_pw_win_change();
extern	void		Dev_pw_reset_to_defaults();
extern	void		Dev_pw_flush();
extern	void		Dev_pw_clear();
extern	void		Dev_pw_setvp_3d();
extern	void		Dev_pw_setvp_2d();
extern	void		Dev_pw_viewport_2d() ;
extern	void		Dev_pw_viewport_3d() ;
extern	void		Dev_pw_set_color();
extern	void		Dev_pw_set_write_mask();
extern	void		Dev_pw_set_clip_planes();
extern	void		Dev_pw_set_hidden_surf();
extern	void		Dev_pw_set_rop_mode();
extern	void		Dev_pw_set_z_buffer_depth();
extern	void		Dev_pw_set_matrix_3d();
extern	void		Dev_pw_set_matrix_2d();
extern	void		Dev_pw_select_matrix();
extern	void		Dev_pw_matrix_mul_2d();
extern	void		Dev_pw_matrix_mul_3d();
extern	void		Dev_pw_get_matrix_2d();
extern	void		Dev_pw_get_matrix_3d();
extern	int		Dev_pw_polygon_2df() ;
extern	int		Dev_pw_polygon_2di() ;
extern	int		Dev_pw_polygon_3df() ;
extern	int		Dev_pw_polygon_3df_gouraud() ;
extern	int		Dev_pw_polygon_3di() ;
extern	int		Dev_pw_polygon_3di_gouraud() ;
extern	int		Dev_pw_get_texture_block() ;
extern	void		Dev_pw_free_texture_block() ;
extern	void		Dev_pw_select_texture_block() ;
extern	void		Dev_pw_set_texture_org_screen();
extern	void		Dev_pw_set_texture_org_2df();
extern	void		Dev_pw_set_texture_org_3df();
extern	int		Dev_pw_set_polygon_texture();
extern	void		Dev_pw_print();
extern	void		Dev_pw_move_2di();
extern	void		Dev_pw_draw_2di();
extern	void		Dev_pw_move_2df();
extern	void		Dev_pw_draw_2df();
extern	void		Dev_pw_move_3di();
extern	void		Dev_pw_draw_3di();
extern	void		Dev_pw_move_3df();
extern	void		Dev_pw_draw_3df();
extern	void		Dev_pw_set_line_texture();
extern	void		Dev_pw_set_line_width();
extern	void		Dev_pw_set_dbuf() ;
extern	void		Dev_pw_set_sbuf() ;
extern	void		Dev_pw_putcolormap () ;
extern	void		Dev_pw_dbuf_control() ;
extern	void		Dev_pw_dbuf_write_mask() ;
extern	void		Dev_pw_dbuf_color() ;
extern	void		Dev_pw_dbuf_swap() ;
extern	int		Dev_pw_dbuf_get_ctrl() ;
extern	int		Dev_pw_dbuf_get_write_mask() ;
extern	void		Dev_pw_line_2df() ;
extern	void		Dev_pw_line_2di() ;
extern	void		Dev_pw_line_3df() ;
extern	void		Dev_pw_line_3di() ;
extern	void		Dev_pw_mul_points() ;
extern	void		Dev_pw_mul_term() ;
extern	int		Dev_pw_mul_init_2df() ;
extern	void		Dev_pw_mul_add_2df() ;
extern	void		Dev_pw_mul_get_2df() ;
extern	void		Dev_pw_mul_2df() ;
extern	int		Dev_pw_mul_init_2di() ;
extern	void		Dev_pw_mul_add_2di() ;
extern	void		Dev_pw_mul_get_2di() ;
extern	void		Dev_pw_mul_2di() ;
extern	int		Dev_pw_mul_init_3df() ;
extern	void		Dev_pw_mul_add_3df() ;
extern	void		Dev_pw_mul_get_3df() ;
extern	void		Dev_pw_mul_3df() ;
extern	int		Dev_pw_mul_init_3di() ;
extern	void		Dev_pw_mul_add_3di() ;
extern	void		Dev_pw_mul_get_3di() ;
extern	void		Dev_pw_mul_3di() ;
extern	void		Dev_pw_ident_mat() ;
extern	void		Dev_pw_xlate() ;
extern	void		Dev_pw_rotx() ;
extern	void		Dev_pw_roty() ;
extern	void		Dev_pw_rotz() ;
extern	void		Dev_pw_scale() ;
extern	void		Dev_pw_persp() ;
extern	void		Dev_pw_window_mat() ;
extern	void		Dev_pw_point_transform3df() ;
extern	int		Dev_pw_invert_mat() ;
extern	void		Dev_pw_transpose_mat() ;
extern	void		Dev_pw_wait() ;
extern	void		Dev_pw_setcmsname() ;
extern	void		Dev_pw_getcmsname() ;
extern	void		Dev_pw_putcolormap() ;
extern	void		Dev_pw_getcolormap() ;
extern	struct pixwin	*Dev_pw_get_pw() ;
extern	struct pixrect	*Dev_pw_get_pr() ;
extern	struct rect	*Dev_pw_rect() ;


#endif	DEV_PW_DEFINED

