#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_color.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include "dev_pw_internal.h"


/*
 *	These routines handle color-table double buffering
 *
 *
 *	Routines provided here:
 *
 *
 *	Dev_pw_setcmsname(pwh, cmsname)
 *		Set cms name
 *
 *	Dev_pw_getcmsname(pwh, cmsname)
 *		Get cms name
 *
 *	Dev_pw_putcolormap(pwh, start, length, r,g,b)
 *		same as pw_putcolormap or pr_putcolormap
 *
 *	Dev_pw_getcolormap(pwh, start, length, r,g,b)
 *		Retrieve the gp's color map
 *
 *
 *
 *	Edward A. Falk
 *	Sun Microsystems
 *
 *	Sept, 1987
 *
 *
 *
 */


/****
 *
 * Constants,  typedefs, externals, globals, statics, macros, block data
 *
 ****/



void
Dev_pw_setcmsname(pwh, name)
register PW	*pwh ;
	char	*name ;
{
	strncpy(pwh->cmsname, name, CMS_NAMESIZE) ;

	if(pwh->pixw)
	{
	    pw_setcmsname(pwh->pixw,pwh->cmsname) ;
	    _dev_pw_maxmask(pwh) ;
	}
}



void
Dev_pw_getcmsname(pwh, name)
register PW	*pwh ;
	char	name[CMS_NAMESIZE] ;
{
	bcopy(pwh->cmsname, name, CMS_NAMESIZE) ;
}







void
Dev_pw_putcolormap(pwh, start, length, r,g,b)
register PW		*pwh ;
	int		start ;
	int		length ;
	unsigned char	*r, *g, *b ;
{
	int	i,j ;
	struct colormapseg	cms ;

	if(pwh->pixw)
	{
	    pw_putcolormap(pwh->pixw, start, length, r,g,b) ;
	    _dev_pw_maxmask(pwh) ;
	}
	else
	    pr_putcolormap(pwh->pixr, start, length, r,g,b) ;
}



void
Dev_pw_getcolormap(pwh, start, length, r,g,b)
register PW		*pwh ;
	int		start ;
	int		length ;
	unsigned char	*r, *g, *b ;
{
	if(pwh->pixw)
	    pw_getcolormap(pwh->pixw, start, length, r,g,b) ;
	else
	    pr_getcolormap(pwh->pixr, start, length, r,g,b) ;
}
