#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_mat.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

/*
 * This file contains routines for setting and retrieving 3d and 2d
 * matrices.  And for selecting the current matrix.
 */

#include "dev_pw_internal.h"

static	void	get_mat();

extern	int	(*xforms_2d[])() ;
extern	int	(*xforms_3d[])() ;




void
Dev_pw_set_matrix_3d(pwh, index, mat)
register PW		*pwh;
 	int		index;
	Matrix3df	mat ;
{
	bcopy(mat, pwh->mats[index], sizeof(Matrix3df)) ;
	pwh->mtypes[index] = _dev_pw_mat_anal(pwh->mats[index]) ;
	if( pwh->mat_index == index)
	  Dev_pw_select_matrix(pwh, index) ;
}




void
Dev_pw_set_matrix_2d(pwh, index, mat)
register	PW		*pwh;
 		int		index;
register	Matrix2df	mat;
{
register Matrix3df	*omat = (Matrix3df *) pwh->mats[index] ;

	(*omat)[0][0] = mat[0][0] ;
	(*omat)[0][1] = mat[0][1] ;
	(*omat)[0][2] = 0.0 ;
	(*omat)[0][3] = 0.0 ;
	(*omat)[1][0] = mat[1][0] ;
	(*omat)[1][1] = mat[1][1] ;
	(*omat)[1][2] = 0.0 ;
	(*omat)[1][3] = 0.0 ;
	(*omat)[2][0] = 0.0 ;
	(*omat)[2][1] = 0.0 ;
	(*omat)[2][2] = 0.0 ;
	(*omat)[2][3] = 0.0 ;
	(*omat)[3][0] = mat[2][0] ;
	(*omat)[3][1] = mat[2][1] ;
	(*omat)[3][2] = 0.0 ;
	(*omat)[3][3] = 1.0 ;

	pwh->mtypes[index] = _dev_pw_mat_anal(pwh->mats[index]) ;
	if( pwh->mat_index == index)
	  Dev_pw_select_matrix(pwh, index) ;
}



void
Dev_pw_matrix_mul_2d(pwh, result, a, b)
register PW	*pwh;
 	int	result, a, b;
{
	Dev_pw_mul_matrix( pwh->mats[result], 
			   pwh->mats[a],
			   pwh->mats[b]) ;
	pwh->mtypes[result] = _dev_pw_mat_anal(pwh->mats[result]) ;
	if( pwh->mat_index == result)
	  Dev_pw_select_matrix(pwh, result) ;
}


void
Dev_pw_matrix_mul_3d(pwh, result, a, b)
	PW	*pwh;
 	int	result, a, b;
{
	Dev_pw_mul_matrix( pwh->mats[result], 
			   pwh->mats[a],
			   pwh->mats[b]) ;
	pwh->mtypes[result] = _dev_pw_mat_anal(pwh->mats[result]) ;
	if( pwh->mat_index == result)
	  Dev_pw_select_matrix(pwh, result) ;
}
