#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_mul_3di.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include "dev_pw_internal.h"

#define	NUMFIT	100		/* can fit 100 points */


/*
 *		TRANSFORM ROUTINES
 *
 * Dev_pw_mul_3di(pwh, npts, pts, retain)	transform an array of points
 *
 * int
 * Dev_pw_mul_init_3di(pwh)			open transform block
 *						return # points that will fit
 *
 * Dev_pw_mul_add_3di(pwh, x, y, z)		add a point to transform block
 *	int	x,y ;
 *
 * Dev_pw_mul_get_3di(pwh, &x, &y, &z)		get a transformed point
 *
 * Dev_pw_mul_points_3di(pwh)			process transform block
 */



void
Dev_pw_mul_3di(pwh, npts, pts, retain)
register PW		*pwh ;
	int		npts ;
register Point3di	*pts ;
	int		retain ;
{
	Point3df	input ;
	Point4df	result ;

	while(npts-- > 0)
	{
	    input.x = pts->x ;
	    input.y = pts->y ;
	    input.z = pts->z ;
	    (*pwh->xf_func3)(pwh, &input, &result ) ;
	    pts->x = result.x ;
	    pts->y = result.y ;
	    pts->z = result.z ;
	    ++pts ;
	}
}





int
Dev_pw_mul_init_3di(pwh)
register PW	*pwh ;
{
	if( pwh->tmp_buffer != NULL )
	  free( pwh->tmp_buffer ) ;
	pwh->tmp_ptr = pwh->tmp_buffer =
		(caddr_t) malloc( NUMFIT * sizeof(Point3di) ) ;

	return NUMFIT ;
}



void
Dev_pw_mul_add_3di(pwh, x, y, z)
register PW	*pwh ;
	float	x,y,z ;
{
register Point3di	*ptr = (Point3di *) pwh->tmp_ptr ;
	ptr->x = x ;
	ptr->y = y ;
	ptr->z = z ;
	++ptr ;
	pwh->tmp_ptr = (caddr_t) ptr ;
}





void
Dev_pw_mul_get_3di(pwh, x, y, z)
register PW	*pwh ;
	float	*x, *y, *z ;
{
register Point3di	*ptr = (Point3di *) pwh->tmp_ptr ;
	*x = ptr->x ;
	*y = ptr->y ;
	*z = ptr->z ;
	++ptr ;
	pwh->tmp_ptr = (caddr_t) ptr ;
}



void
Dev_pw_mul_points_3di(pwh)
register PW	*pwh ;
{
register Point3di	*p0, *p1 ;

	p0 = (Point3di *) pwh->tmp_buffer ;
	p1 = (Point3di *) pwh->tmp_ptr ;
	Dev_pw_mul_3di(pwh, p1 - p0, pwh->tmp_buffer, 0) ;

	pwh->tmp_ptr = pwh->tmp_buffer ;
}
