#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_point.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

/* Created by Pell 891027 */

#include "dev_pw_internal.h"

/*
 * there are three cases here:
 *
 * 1) persp: endpoints clipped against w, division performed.
 * 2) clip: endpoints clipped against 1, no division.  May use this
 *	case if perspective not turned on in cur_mat.
 * 3) none: points not even mapped (this is handled within cur_mat).
 *	May use this case if no perspective, no clipping *or*
 *	no perspective, viewport is entire window
 */

#ifdef	DEBUG
#define	register
#endif	DEBUG

_dev_pw_persp_point(pwh, pt0)
register PW		*pwh ;
register Point4df	*pt0 ;
{
  register int		clip1 = 0 ;

  if( !pwh->clip_planes ||
     (pwh->cdp_flag | (clip1 = _dev_pw_clip_persp(pwh, pt0))) == 0) {
    register int ix0,iy0;

    ix0 = pt0->x/pt0->w * pwh->view_scl.x + pwh->view_ofs.x ;
    iy0 = pt0->y/pt0->w * pwh->view_scl.y + pwh->view_ofs.y ;

    if( pwh->pixw )
      pw_vector(pwh->pixw, ix0,iy0,ix0,iy0, pwh->rop, pwh->color) ;
    else
      pr_vector(pwh->pixr, ix0,iy0,ix0,iy0, pwh->rop, pwh->color) ;
  }
  return clip1 ;
}

_dev_pw_clip_point(pwh, pt0)
register PW		*pwh ;
register Point4df	*pt0 ;
{
  register int		clip1 = 0 ;

  if( !pwh->clip_planes ||
     (pwh->cdp_flag | (clip1 = _dev_pw_clip(pwh, pt0))) == 0) {
    register int ix0,iy0;

    ix0 = pt0->x * pwh->view_scl.x + pwh->view_ofs.x ;
    iy0 = pt0->y * pwh->view_scl.y + pwh->view_ofs.y ;

    if( pwh->pixw )
      pw_vector(pwh->pixw, ix0,iy0,ix0,iy0, pwh->rop, pwh->color) ;
    else
      pr_vector(pwh->pixr, ix0,iy0,ix0,iy0, pwh->rop, pwh->color) ;
  }
  return clip1 ;
}

_dev_pw_point(pwh, pt0)
register PW		*pwh ;
register Point4df	*pt0 ;
{
  register int		x0,y0;

  x0 = pt0->x ;
  y0 = pt0->y ;

  if( pwh->pixw )
    pw_vector(pwh->pixw, x0,y0,x0,y0, pwh->rop, pwh->color) ;
  else
    pr_vector(pwh->pixr, x0,y0,x0,y0, pwh->rop, pwh->color) ;

  return 0 ;
}
