#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_poly.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


#include <stdio.h>
#include <sunwindow/window_hs.h>
#include "dev_pw_internal.h"


#ifdef	DEBUG
#define	register
#define	showvec()	if(vlptr != vlist)	\
			  pw_vector(pwh->pixw, (vlptr-1)->x,(vlptr-1)->y, \
			    vlptr->x, vlptr->y, pwh->rop, pwh->color )
#else	DEBUG
#define	showvec()
#endif	DEBUG


#define	MALLOC(type,n)	( (type *) malloc((n)*sizeof(type)) )



int
_dev_pw_poly(pwh, n_bounds, bounds, tot_verts, pts, clip, shade)
register PW		*pwh;
	int		n_bounds;	/* # bounds			*/
	int		bounds[];	/* # verts for each bound	*/
	int		tot_verts ;	/* sum(bounds)			*/
	Point4df	*pts;		/* xyzw points			*/
	int		clip[] ;	/* clip flags			*/
	int		shade;		/* shading control		*/
{
	struct pr_pos	*vlist ;	/* output vertex list */
	int		bnd_list[20] ;	/* output bounds list */
	int		c0,c1 ;


	switch(pwh->view_type)
	{
	  case V_COMP:
	    {
	      register struct pr_pos *vlptr ;
	      register Point4df *p0 ;
	      register int i ;

	      vlist = MALLOC( struct pr_pos, tot_verts ) ;
	      vlptr = vlist ;
	      p0 = pts ;
	      for(i=tot_verts; --i >= 0;)
	      {
		vlptr->x = p0->x ;
		vlptr->y = p0->y ;
		++vlptr ;
		++p0 ;
	      }
	      pw_polygon_2(pwh->pixw, 0,0, n_bounds, bounds, vlist,
		      PIX_COLOR(pwh->color) | PIX_SRC, NULL, 0,0) ;
	      free( vlist ) ;
	    }
	    break ;













	  case V_FULL:
	  case V_PERSP:
	    {
	      register int i = n_bounds, *ptr = bounds, *ptr2 = bnd_list ;
	      while(--i >= 0)
		*ptr2++ = *ptr++ ;
	    }

	    if( !pwh->clip_planes )	/* very trivial accept ? */
	    {
	      if(pwh->view_type == V_PERSP)
		poly_persp(pwh, n_bounds, bnd_list, tot_verts, pts, shade) ;
	      else
		poly_full(pwh, n_bounds, bnd_list, tot_verts, pts, shade) ;
	    }

	    else
	    {
	      register int co = 0 ;
	      {
		register int ca = ~0 ;
		register int *clptr = clip, i = tot_verts ;

		while( --i >= 0 )
		{
		  co |= *clptr ;
		  ca &= *clptr++ ;
		}
		if ( ca != 0 )		/* trivial reject ? */
		  return ;
	      }
	      if ( co == 0 )		/* trivial accept ? */
	      {
		if(pwh->view_type == V_PERSP)
		  poly_persp(pwh, n_bounds, bnd_list, tot_verts, pts, shade) ;
		else
		  poly_full(pwh, n_bounds, bnd_list, tot_verts, pts, shade) ;
	      }
	      else
	      {
		Point4df *p0, *p1, *p2 ;
		int	*c0, *c1, *c2 ;

		p0 = pts ;
		p1 = MALLOC( Point4df, tot_verts*2 ) ;
		p2 = MALLOC( Point4df, tot_verts*2 ) ;
		c0 = clip ;
		c1 = MALLOC( int, tot_verts*2 ) ;
		c2 = MALLOC( int, tot_verts*2 ) ;

		if( co & PW_CLIP_LEFT )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_LEFT) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_LEFT) ;
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		if( co & PW_CLIP_RIGHT )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_RIGHT) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_RIGHT) ;
		  if( p0 != pts )
		  {
		    p2 = p0 ; c2 = c0 ;
		  }
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		if( co & PW_CLIP_BOTTOM )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_BOTTOM) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_BOTTOM) ;
		  if( p0 != pts )
		  {
		    p2 = p0 ; c2 = c0 ;
		  }
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		if( co & PW_CLIP_TOP )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_TOP) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_TOP) ;
		  if( p0 != pts )
		  {
		    p2 = p0 ; c2 = c0 ;
		  }
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		if( co & PW_CLIP_HITHER )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_HITHER) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_HITHER) ;
		  if( p0 != pts )
		  {
		    p2 = p0 ; c2 = c0 ;
		  }
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		if( co & PW_CLIP_YON )
		{
		  if(pwh->view_type == V_PERSP)
		    tot_verts = clip_p(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_YON) ;
		  else
		    tot_verts = clip_f(pwh,&n_bounds, bnd_list,
			p0, p1, c0, c1, PW_CLIP_YON) ;
		  if( p0 != pts )
		  {
		    p2 = p0 ; c2 = c0 ;
		  }
		  p0 = p1 ; c0 = c1 ;
		  p1 = p2 ; c1 = c2 ;
		}

		free( p1 ) ; free ( c1 ) ;

		if(pwh->view_type == V_PERSP)
		  poly_persp(pwh, n_bounds, bnd_list, tot_verts, p0, shade) ;
		else
		  poly_full(pwh, n_bounds, bnd_list, tot_verts, p0, shade) ;

		if( p0 != pts )
		{
		  free( p0 ) ; free( c0 ) ;
		}
		else
		{
		  fprintf(stderr, "? p0 == pts in _dev_pw_poly\n") ;
		  free( p2 ) ; free ( c2 ) ;
		}
	      }
	    }
	    break ;
	}
}





static
poly_full(pwh, n_bounds, bounds, tot_verts, pts, shade)
register PW		*pwh;
	int		n_bounds;	/* # bounds			*/
	int		bounds[];	/* # verts for each bound	*/
	int		tot_verts ;	/* sum(bounds)			*/
	Point4df	*pts ;		/* xyzw points			*/
	int		shade;		/* shading control		*/
{
	struct pr_pos	*vlist ;
register struct pr_pos	*vlptr ;
register Point4df	*p0 ;
register int		i ;

	vlist = MALLOC( struct pr_pos, tot_verts ) ;
	vlptr = vlist ;
	p0 = pts ;
	for(i=tot_verts; --i >= 0;)
	{
	  vlptr->x = p0->x * pwh->view_scl.x + pwh->view_ofs.x ;
	  vlptr->y = p0->y * pwh->view_scl.y + pwh->view_ofs.y ;
	  ++vlptr ;
	  ++p0 ;
	}
	pw_polygon_2(pwh->pixw, 0,0, n_bounds, bounds, vlist,
		PIX_COLOR(pwh->color) | PIX_SRC, NULL, 0,0) ;
	free( vlist ) ;
}





static
poly_persp(pwh, n_bounds, bounds, tot_verts, pts, shade)
register PW		*pwh;
	int		n_bounds;	/* # bounds			*/
	int		bounds[];	/* # verts for each bound	*/
	int		tot_verts ;	/* sum(bounds)			*/
	Point4df	*pts ;		/* xyzw points			*/
	int		shade;		/* shading control		*/
{
	struct pr_pos	*vlist ;
register struct pr_pos	*vlptr ;
register Point4df	*p0 ;
register int		i ;

	vlist = MALLOC( struct pr_pos, tot_verts ) ;
	vlptr = vlist ;
	p0 = pts ;
	for(i=tot_verts; --i >= 0;)
	{
	  vlptr->x = p0->x / p0->w * pwh->view_scl.x + pwh->view_ofs.x ;
	  vlptr->y = p0->y / p0->w * pwh->view_scl.y + pwh->view_ofs.y ;
	  ++vlptr ;
	  ++p0 ;
	}
	pw_polygon_2(pwh->pixw, 0,0, n_bounds, bounds, vlist,
		PIX_COLOR(pwh->color) | PIX_SRC, NULL, 0,0) ;
	free( vlist ) ;
}




static	int
clip_f(pwh, n_bounds, bnd_list, in, out, cin, cout, mask)
	PW		*pwh;
	int		*n_bounds, bnd_list[] ;
register Point4df	*in, *out ;
	int		*cin, *cout, mask ;
{
	int		*ibptr = bnd_list, *obptr = bnd_list ;
	int		i,j ;
	int		clast, cthis ;
	Point4df	*plast ;
	int		inbounds = *n_bounds ;
	int		inverts, outverts ;
	int		totverts = 0 ;

	for(i=0; i<inbounds; ++i)
	{
	  plast = in + bnd_list[i] - 1 ;
	  clast = *(cin + bnd_list[i] - 1) & mask ;
	  inverts = *ibptr++ ;
	  outverts = 0 ;
	  for(j=0; j<inverts; ++j)
	  {
	    /* four cases:
	     *	1) in->in:	output endpoint
	     *	2) in->out:	output clippoint
	     *	3) out->out:	do nothing
	     *	4) out->in:	output clippoint & endpoint
	     */
	    cthis = *cin & mask ;
	    if( cthis != clast )	/* output clippoint */
	    {
	      register Point4df *p0 = plast ;
	      register float t, t2 ;
	      switch(mask)
	      {
		case PW_CLIP_LEFT:
		  t = (-1.0 - p0->x)/(in->x - p0->x) ; break ;
		case PW_CLIP_RIGHT:
		  t = (1.0 - p0->x)/(in->x - p0->x) ; break ;
		case PW_CLIP_BOTTOM:
		  t = (-1.0 - p0->y)/(in->y - p0->y) ; break ;
		case PW_CLIP_TOP:
		  t = (1.0 - p0->y)/(in->y - p0->y) ; break ;
		case PW_CLIP_HITHER:
		  t = (- p0->z)/(in->z - p0->z) ; break ;
		case PW_CLIP_YON:
		  t = (1.0 - p0->z)/(in->z - p0->z) ; break ;
	      }
	      out->x = p0->x + (in->x - p0->x)*t ;
	      out->y = p0->y + (in->y - p0->y)*t ;
	      out->z = p0->z + (in->z - p0->z)*t ;
	      *cout++ = _dev_pw_clip(pwh, out) ;
	      ++out ;
	      ++outverts ;
	    }

	    if( !cthis )		/* output endpoint */
	    {
	      out->x = in->x ;
	      out->y = in->y ;
	      out->z = in->z ;
	      ++out ;
	      *cout++ = *cin ;
	      ++outverts ;
	    }
	    clast = cthis ;
	    plast = in++ ;
	    ++cin ;
	  }
	  if( outverts > 0 )
	  {
	    *obptr++ = outverts ;
	    totverts += outverts ;
	  }
	  else
	    --(*n_bounds) ;
	}
	return totverts ;
}



static	int
clip_p(pwh, n_bounds, bnd_list, in, out, cin, cout, mask)
	PW		*pwh;
	int		*n_bounds, bnd_list[] ;
register Point4df	*in, *out ;
	int		*cin, *cout, mask ;
{
	int		*ibptr = bnd_list, *obptr = bnd_list ;
	int		i,j ;
	int		clast, cthis ;
	Point4df	*plast ;
	int		inbounds = *n_bounds ;
	int		inverts, outverts ;
	int		totverts = 0 ;

	for(i=0; i<inbounds; ++i)
	{
	  plast = in + bnd_list[i] - 1 ;
	  clast = *(cin + bnd_list[i] - 1) & mask ;
	  inverts = *ibptr++ ;
	  outverts = 0 ;
	  for(j=0; j<inverts; ++j)
	  {
	    cthis = *cin & mask ;
	    if( cthis != clast )	/* output clippoint */
	    {
	      register Point4df *p0 = plast ;
	      register float t, t2 ;
	      switch(mask)
	      {
		case PW_CLIP_LEFT:
		  t = (p0->w + p0->x)/(p0->x - in->x + p0->w - in->w) ;
		  break ;
		case PW_CLIP_RIGHT:
		  t = (p0->w - p0->x)/(in->x - p0->x + p0->w - in->w) ;
		  break ;
		case PW_CLIP_BOTTOM:
		  t = (p0->w + p0->y)/(p0->y - in->y + p0->w - in->w) ;
		  break ;
		case PW_CLIP_TOP:
		  t = (p0->w - p0->y)/(in->y - p0->y + p0->w - in->w) ;
		  break ;
		case PW_CLIP_HITHER:
		  t = (p0->z)/(p0->z - in->z) ;
		  break ;
		case PW_CLIP_YON:
		  t = (p0->w - p0->z)/(in->z - p0->z + p0->w - in->w) ;
		  break ;
	      }
	      out->x = p0->x + (in->x - p0->x)*t ;
	      out->y = p0->y + (in->y - p0->y)*t ;
	      out->z = p0->z + (in->z - p0->z)*t ;
	      out->w = p0->w + (in->w - p0->w)*t ;
	      *cout++ = _dev_pw_clip_persp(pwh, out) ;
	      ++out ;
	      ++outverts ;
	    }

	    if( !cthis )		/* output endpoint */
	    {
	      out->x = in->x ;
	      out->y = in->y ;
	      out->z = in->z ;
	      out->w = in->w ;
	      ++out ;
	      *cout++ = *cin ;
	      ++outverts ;
	    }
	    clast = cthis ;
	    plast = in++ ;
	    ++cin ;
	  }
	  if( outverts > 0 )
	  {
	    *obptr++ = outverts ;
	    totverts += outverts ;
	  }
	  else
	    --(*n_bounds) ;
	}
	return totverts ;
}


