#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_setvp_3d.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */


/******
 * Dev_pw_setvp_3d(pwh, scale, offset)
 *
 * This function lets the application set the gp scale and offset
 * from direct data.  The utility of doing this is questionable at
 * best.  Use Dev_pw_viewport_3d instead
 *
 * The effects of this call last only until the next time the window is
 * moved.
 ******/


#include "dev_pw_internal.h"

static	Matrix3df	identity = {
	  {1.0, 0.0, 0.0, 0.0},
	  {0.0, 1.0, 0.0, 0.0},
	  {0.0, 0.0, 1.0, 0.0},
	  {0.0, 0.0, 0.0, 1.0}} ;


void
Dev_pw_setvp_3d(pwh, scale, offset)
register PW		*pwh;
register Point3df	*scale, *offset;
{
	pwh->view_scl.x = scale->x ;
	pwh->view_scl.y = scale->y ;
	pwh->view_scl.z = scale->z ;
	pwh->view_ofs.x = offset->x ;
	pwh->view_ofs.y = offset->y ;
	pwh->view_ofs.z = offset->z ;

	if( pwh->view_type == V_COMP )
	{
	  Matrix3df m0 ;
	  bcopy(identity,m0,sizeof(Matrix3df)) ;
	  m0[0][0] = pwh->view_scl.x ;
	  m0[1][1] = pwh->view_scl.y ;
	  m0[2][2] = pwh->view_scl.z ;
	  m0[3][0] = pwh->view_ofs.x ;
	  m0[3][1] = pwh->view_ofs.y ;
	  m0[3][2] = pwh->view_ofs.z ;
	  Dev_pw_mul_matrix( pwh->comp_mat, pwh->mats[pwh->mat_index], m0) ;
	  pwh->mat_type = _dev_pw_mat_anal(pwh->comp_mat) ;
	}
}
