#ifndef lint
static	char	sccsid[] = "@(#)dev_pw_vec.c 1.1 88/11/23 SMI" ;
#endif

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

#include "dev_pw_internal.h"



/*
 * there are three cases here:
 *
 * 1) persp: endpoints clipped against w, division performed.
 * 2) clip: endpoints clipped against 1, no division.  May use this
 *	case if perspective not turned on in cur_mat.
 * 3) none: points not even mapped (this is handled within cur_mat).
 *	May use this case if no perspective, no clipping *or*
 *	no perspective, viewport is entire window
 */


#ifdef	DEBUG
#define	register
#endif	DEBUG



_dev_pw_persp_vector(pwh, pt0, pt1)
register PW		*pwh ;
register Point4df	*pt0, *pt1 ;
{
register int		clip1 = 0 ;

	if( !pwh->clip_planes )
	  goto accept ;

	clip1 = _dev_pw_clip_persp(pwh, pt1) ;

	if( (pwh->cdp_flag & clip1) != 0 )
	  goto reject ;

	if( (pwh->cdp_flag | clip1) == 0 )
	  goto accept ;

	{
	  int i ;
	  register Point4df *p0,*p1 ;
	  register int c0 ;
	  register float t,t2 ;
	  register float x0,y0,z0,w0,x1,y1,z1,w1 ;


	  for(i=0; i<2; ++i)
	  {
	    if(i==0)
	    {
	      p0=pt0 ;
	      p1=pt1 ;
	      c0=pwh->cdp_flag ;
	    }
	    else
	    {
	      p0=pt1 ;
	      p1=pt0 ;
	      c0=clip1 ;
	    }

	    if(c0)
	    {
	      x0 = p0->x ;
	      y0 = p0->y ;
	      z0 = p0->z ;
	      w0 = p0->w ;
	      x1 = p1->x ;
	      y1 = p1->y ;
	      z1 = p1->z ;
	      w1 = p1->w ;

	      t = 1.0 ;

	      if(c0 & (PW_CLIP_LEFT|PW_CLIP_RIGHT))
	      {
		t2 = (c0 & PW_CLIP_RIGHT) ?
			(w1-x1)/(x0-x1+w1-w0) :
			(w1+x1)/(x1-x0+w1-w0) ;
		if( t2 <= 0.0 )
		  goto reject ;
		if(t2 < 1.0)
		  t = t2 ;
	      }
	      if(c0 & (PW_CLIP_BOTTOM|PW_CLIP_TOP))
	      {
		t2 = (c0 & PW_CLIP_TOP) ?
			(w1-y1)/(y0-y1+w1-w0) :
			(w1+y1)/(y1-y0+w1-w0) ;
		if( t2 <= 0.0 )
		  goto reject ;
		if(t2 < t)
		  t = t2 ;
	      }
	      if(c0 & PW_CLIP_HITHER)
	      {
		t2 = z1/(z1 - z0) ;
		if( t2 <= 0.0 )
		  goto reject ;
		if(t2 < t)
		  t = t2 ;
	      }
	      else if(c0 & PW_CLIP_YON)
	      {
		t2 = (w1-z1)/(z0-z1+w1-w0) ;
		if( t2 <= 0.0 )
		  goto reject ;
		if(t2 < t)
		  t = t2 ;
	      }
	      if(x0 != x1)
		p0->x = x1 + t*(x0-x1) ;
	      if(y0 != y1)
		p0->y = y1 + t*(y0-y1) ;
	      if(z0 != z1)
		p0->z = z1 + t*(z0-z1) ;
	      if(w0 != w1)
		p0->w = w1 + t*(w0-w1) ;
	    }
	  }
	}

accept:
	{
	  register int ix0,iy0,ix1,iy1 ;

	  ix0 = pt0->x/pt0->w * pwh->view_scl.x + pwh->view_ofs.x ;
	  iy0 = pt0->y/pt0->w * pwh->view_scl.y + pwh->view_ofs.y ;
	  ix1 = pt1->x/pt1->w * pwh->view_scl.x + pwh->view_ofs.x ;
	  iy1 = pt1->y/pt1->w * pwh->view_scl.y + pwh->view_ofs.y ;

	  if( pwh->pixw )
	    pw_vector(pwh->pixw, ix0,iy0,ix1,iy1, pwh->rop, pwh->color) ;
	  else
	    pr_vector(pwh->pixr, ix0,iy0,ix1,iy1, pwh->rop, pwh->color) ;
	}

reject:
	return clip1 ;
}






_dev_pw_clip_vector(pwh, pt0, pt1)
register PW		*pwh ;
register Point4df	*pt0, *pt1 ;
{
register int		clip1 = 0 ;

	if( !pwh->clip_planes )
	  goto accept ;

	clip1 = _dev_pw_clip(pwh, pt1) ;

	if( (pwh->cdp_flag & clip1) != 0 )
	  goto reject ;

	if( (pwh->cdp_flag | clip1) == 0 )
	  goto accept ;

	{
	  int i ;
	  register Point4df *p0,*p1 ;
	  register int c0 ;
	  register float t,t2 ;
	  register float x0,y0,z0,x1,y1,z1 ;


	  for(i=0; i<2; ++i)
	  {
	    if(i==0)
	    {
	      p0=pt0 ;
	      p1=pt1 ;
	      c0=pwh->cdp_flag ;
	    }
	    else
	    {
	      p0=pt1 ;
	      p1=pt0 ;
	      c0=clip1 ;
	    }

	    if(c0)
	    {
	      x0 = p0->x ;
	      y0 = p0->y ;
	      z0 = p0->z ;
	      x1 = p1->x ;
	      y1 = p1->y ;
	      z1 = p1->z ;

	      t = 1.0 ;

	      if(c0 & (PW_CLIP_LEFT|PW_CLIP_RIGHT))
	      {
		t2 = ((c0 & PW_CLIP_RIGHT ? 1.0 : -1.0) - x1) / (x0-x1) ;
		if(t2 <= 0.0)
		  goto reject ;
		if(t2 < 1.0)
		  t = t2 ;
	      }
	      if(c0 & (PW_CLIP_BOTTOM|PW_CLIP_TOP))
	      {
		t2 = ((c0 & PW_CLIP_TOP ? 1.0 : -1.0) - y1) / (y0-y1) ;
		if(t2 <= 0.0)
		  goto reject ;
		if(t2 < t)
		  t = t2 ;
	      }
	      if(c0 & (PW_CLIP_HITHER|PW_CLIP_YON))
	      {
		t2 = ((c0 & PW_CLIP_YON ? 1.0 : 0.0) - z1) / (z0-z1) ;
		if(t2 <= 0.0)
		  goto reject ;
		if(t2 < t)
		  t = t2 ;
	      }
	      if(x0 != x1)
		p0->x = x1 + t*(x0-x1) ;
	      if(y0 != y1)
		p0->y = y1 + t*(y0-y1) ;
	      if(z0 != z1)
		p0->z = z1 + t*(z0-z1) ;
	    }
	  }
	}

accept:
	{
	  register int ix0,iy0,ix1,iy1 ;

	  ix0 = pt0->x * pwh->view_scl.x + pwh->view_ofs.x ;
	  iy0 = pt0->y * pwh->view_scl.y + pwh->view_ofs.y ;
	  ix1 = pt1->x * pwh->view_scl.x + pwh->view_ofs.x ;
	  iy1 = pt1->y * pwh->view_scl.y + pwh->view_ofs.y ;

	  if( pwh->pixw )
	    pw_vector(pwh->pixw, ix0,iy0,ix1,iy1, pwh->rop, pwh->color) ;
	  else
	    pr_vector(pwh->pixr, ix0,iy0,ix1,iy1, pwh->rop, pwh->color) ;
	}

reject:
	return clip1 ;
}






_dev_pw_vector(pwh, pt0, pt1)
register PW		*pwh ;
register Point4df	*pt0, *pt1 ;
{
register int		x0,y0,x1,y1 ;

	x0 = pt0->x ;
	y0 = pt0->y ;
	x1 = pt1->x ;
	y1 = pt1->y ;

	if( pwh->pixw )
	  pw_vector(pwh->pixw, x0,y0,x1,y1, pwh->rop, pwh->color) ;
	else
	  pr_vector(pwh->pixr, x0,y0,x1,y1, pwh->rop, pwh->color) ;

	return 0 ;
}
