#ifndef	lint
static	char	sccsid[] = "@(#)create_tower.c 1.2 89/03/10 SMI" ;
#endif

#include <stdio.h>
#include "graphics.h"
#include "object_types.h"


extern	View_Node	view1 ;


	Named_Object	tower_object = {
	  NAMED_OBJECT,
	  draw_named_object,
	  0, "tower", NULL,
	  OBJ_STATIC,
	  {-20.,-20.,0.},{20.,20.,50.},
	  (Desc_Node *) &view1,
	  NULL,
	} ;

static	Point3df	line1_pnts[] = {
	  {-7.5,-7.5,28.}, {-5.,-5.,20.},
	  {-7.5, 7.5,28.}, {-5., 5.,20.},
	  { 7.5,-7.5,28.}, { 5.,-5.,20.},
	  { 7.5, 7.5,28.}, { 5., 5.,20.}} ;

static	Polyline_Node	line1d = {
	  POLYLINE_NODE,
	  draw_polyline_node,
	  RED, 2, &line1_pnts[6], NULL,
	} ;

static	Polyline_Node	line1c = {
	  POLYLINE_NODE,
	  draw_polyline_node,
	  RED, 2, &line1_pnts[4], &line1d,
	} ;

static	Polyline_Node	line1b = {
	  POLYLINE_NODE,
	  draw_polyline_node,
	  RED, 2, &line1_pnts[2], &line1c,
	} ;

static	Polyline_Node	line1 = {
	  POLYLINE_NODE,
	  draw_polyline_node,
	  RED, 2, &line1_pnts[0], &line1b,
	} ;

static	Point3df	pnts6[] = {
	  {-5., 5., 0.},
	  { 5., 5., 0.},
	  { 5., 5.,20.},
	  {-5., 5.,20.}} ;

static	Bsp_Node	bsp6 = {	/* +y wall */
	  BSP_NODE,
	  draw_bsp_node,
	  {0.,5.,10.},
	  {0.,1.,0.},
	  WHITE, -1, -1,-1,
	  1, {4,0,0}, pnts6,
	  NULL, NULL,
	} ;

static	Point3df	pnts5[] = {
	  {-5.,-5., 0.},
	  { 5.,-5., 0.},
	  { 5.,-5.,20.},
	  {-5.,-5.,20.}} ;

static	Bsp_Node	bsp5 = {	/* -y wall */
	  BSP_NODE,
	  draw_bsp_node,
	  {0.,-5.,10.},
	  {0.,-1.,0.},
	  LGREY, -1, -1,-1,
	  1, {4,0,0}, pnts5,
	  NULL, (Desc_Node *) &bsp6,
	} ;

static	Point3df	pnts4[] = {
	  { 5.,-5., 0.},
	  { 5., 5., 0.},
	  { 5., 5.,20.},
	  { 5.,-5.,20.}} ;

static	Bsp_Node	bsp4 = {	/* +x wall */
	  BSP_NODE,
	  draw_bsp_node,
	  { 5.,0.,10.},
	  { 1.,0.,0.},
	  LGREY, -1, BLACK,-1,
	  1, {4,0,0}, pnts4,
	  NULL, (Desc_Node *) &bsp5,
	} ;

static	Point3df	pnts3[] = {
	  {-5.,-5., 0.},
	  {-5., 5., 0.},
	  {-5., 5.,20.},
	  {-5.,-5.,20.}} ;

static	Bsp_Node	bsp3 = {	/* -x wall */
	  BSP_NODE,
	  draw_bsp_node,
	  {-5.,0.,10.},
	  {-1.,0.,0.},
	  WHITE,-1, BLACK,-1,
	  1, {4,0,0}, pnts3,
	  NULL, (Desc_Node *) &bsp4,
	} ;

static	Point3df	pnts2[] = {
	  {-5.,-5.,20.},
	  {-5., 5.,20.},
	  { 5., 5.,20.},
	  { 5.,-5.,20.}} ;

static	Bsp_Node	bsp2 = {	/* panel on top of tower */
	  BSP_NODE,
	  draw_bsp_node,
	  {0.,0.,20.},
	  {0.,0.,1.},
	  GREY, -1, BLACK, -1,
	  1, {4,0,0}, pnts2,
	  (Desc_Node *) &line1, (Desc_Node *) &bsp3,
	} ;

static	Point3df	pnts1[] = {
	  {-7.5,-7.5,28.},
	  {-7.5, 7.5,28.},
	  { 7.5, 7.5,28.},
	  { 7.5,-7.5,28.}} ;

static	Bsp_Node	bsp1 = {	/* panel on rooftop */
	  BSP_NODE,
	  draw_bsp_node,
	  {0.,0.,28.},
	  {0.,0.,1.},
	  LGREY, GREY, BLACK, -1,
	  1, {4,0,0}, pnts1,
	  NULL, (Desc_Node *) &bsp2,
	} ;

static	Point3df	tower_pts[] =
	  {{0.,0.,0.},{0.,0.,28.}} ;

static	Polyline_Node	tower_line = {
	  POLYLINE_NODE,
	  draw_polyline_node,
	  LGREY, 2, tower_pts, NULL,
	} ;

static	View_Node	view2 = {
	  VIEW_NODE,
	  draw_view_node,
	  {0.,0.,0.},
	  0., NULL, (Desc_Node *) &bsp1,
	} ;


static	View_Node	view1 = {	/* far away is just a line */
	  VIEW_NODE,
	  draw_view_node,
	  {0.,0.,0.},
	  2000.*2000., &view2, (Desc_Node *) &tower_line,
	} ;
