#ifndef lint
static	char sccsid[] = "%Z%%M% %I% %E% SMI";
#endif

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

#include <fcntl.h>
#include <stdio.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <suntool/sunview.h>
#include <suntool/canvas.h>
#include <suntool/panel.h>
#include <sunwindow/pw_dblbuf.h>
#include "gfx.h"
#include "flight.h"
#include "object_types.h"
#include "graphics.h"

#ifdef	FD_SET		/* kludge, find out if we're under 4.x */
#define	OS4
#endif	FD_SET





	Frame		Main_Frame ;
	Canvas		Main_Canvas ;
	Cursor		Main_Cursor ;
	Cursor		Default_Cursor ;
	Frame		Props_frame ;
	Panel		Props_panel ;
	Pixwin		*Main_pw ;
	struct pixfont	*Main_font, *Small_font ; ;
	Gfx_context	Main_gfx ;

static	struct timeval	First_Time ;
static	struct timeval	Last_Poll ;
static	struct timeval	countdown ;
static	int		sigint() ;

static	int		nframes ;

static	unsigned char	red[]   = {  0, 255, 192, 128, 255,   0,   0, 255 } ;
static	unsigned char	green[] = {  0, 255, 192, 128,   0, 255,   0, 255 } ;
static	unsigned char	blue[]  = { 64, 255, 192, 128,   0,   0, 255,   0 } ;


static	short	flight_icon[] = {
#include "flight.icon"
} ;
DEFINE_ICON_FROM_IMAGE(Main_Icon, flight_icon) ;



static	short	flight_cursor[] = {
#include "cursor2.pr"
} ;
mpr_static(flight_pr, 16, 16, 1, flight_cursor) ;



static	void		Canvas_Proc() ;
static	void		Canvas_Resize_Proc() ;
static	void		panel_start() ;
static	Notify_value	Destroy_func(), Close_func() ;
	void		timefunc(), sleepfunc() ;

main(argc,argv)
int	argc;
char	**argv;
{
	int	i,j,k,iret ;
	int	c ;
	Point3df	p1, p2, p3, p4, p5 ;

	char		cmsname[CMS_NAMESIZE] ;

	gettimeofday(&Now, NULL) ;
	Daytime = Now ;
	Last_Time.tv_sec = -1 ;
	Last_Poll = Now ;

	debug_level = 0 ;

	srandom(getpid()) ;

	Main_Timer.it_interval.tv_usec = DISPLAY_INTERVAL ;
	Main_Timer.it_interval.tv_sec = 0;
	Main_Timer.it_value.tv_usec = 0 ;
	Main_Timer.it_value.tv_sec = 1 ;

	Sleep_Timer.it_interval.tv_usec = 0 ;
	Sleep_Timer.it_interval.tv_sec = SLEEP_INTERVAL ;
	Sleep_Timer.it_value.tv_usec = 0 ;
	Sleep_Timer.it_value.tv_sec = SLEEP_INTERVAL ;


	Main_Frame = window_create(NULL, FRAME,
	    FRAME_ICON, &Main_Icon,
	    FRAME_LABEL, "Flight - experimental",
	    WIN_WIDTH, 1152,
	    WIN_HEIGHT, 900,
	    WIN_X, 0,
	    WIN_Y, 0,
	    FRAME_ARGC_PTR_ARGV, &argc, argv,
#ifdef	OS4
	    FRAME_PROPS_ACTION_PROC,	panel_start,
	    FRAME_PROPS_ACTIVE,		TRUE,
	    WIN_CONSUME_KBD_EVENT,	ACTION_PROPS,
#endif	OS4
	0 ) ;
	if(Main_Frame == NULL)
	  exit(1) ;

	Main_Cursor = cursor_create(
	    CURSOR_IMAGE, &flight_pr,
	    CURSOR_XHOT, 8, CURSOR_YHOT, 8,
	0 ) ;
	if(Main_Cursor == NULL)
	{
	  puts("Can't create cursor") ;
	  exit(1) ;
	}

	Main_Canvas = window_create(Main_Frame, CANVAS,
	    WIN_EVENT_PROC, Canvas_Proc,
	    CANVAS_RESIZE_PROC, Canvas_Resize_Proc,
	    CANVAS_RETAINED, FALSE,
	    WIN_CONSUME_PICK_EVENTS, WIN_NO_EVENTS, WIN_MOUSE_BUTTONS,
	      LOC_MOVE, WIN_ASCII_EVENTS, WIN_IN_TRANSIT_EVENTS,
	      WIN_LEFT_KEYS, WIN_RIGHT_KEYS, WIN_TOP_KEYS,
	      LOC_WINEXIT, LOC_RGNEXIT, 0,
	    WIN_CONSUME_KBD_EVENT, WIN_NO_EVENTS,
	0 ) ;
	if(Main_Canvas == NULL)
	  exit(1) ;

	Default_Cursor = (Cursor) window_get(Main_Canvas, WIN_CURSOR) ;
	Default_Cursor = cursor_copy(Default_Cursor) ;

	Main_font = pf_open("/usr/lib/fonts/fixedwidthfonts/screen.r.11") ;
	Small_font = pf_open("/usr/lib/fonts/fixedwidthfonts/screen.r.7") ;

	notify_interpose_destroy_func(Main_Frame, Destroy_func) ;
	notify_interpose_event_func(Main_Frame, Close_func, NOTIFY_SAFE) ;


	Main_pw = (Pixwin *) window_get(Main_Canvas, CANVAS_PIXWIN) ;
	Main_gfx = Gfx_create(Main_pw, 3, &iret) ;
	if(!Main_gfx) {
	  printf("can't open gfx, err=%d\n",iret) ;
	  exit(1) ;
	}
	Gfx_reset_to_defaults(Main_gfx) ;

	Me_Posn.x = 0.0 ;
	Me_Posn.y = -3800.0 ;
	Me_Posn.z =  244.0 ;
	Me_Heading = 0.0 ; Head_sin = 0.0 ; Head_cos = 1.0 ;
	Me_Pitch = 0.0 ; Pitch_sin = 0.0 ; Pitch_cos = 1.0 ;
	Me_Roll = 0.0 ; Roll_sin = 0.0 ; Roll_cos = 1.0 ;
	Me_Forward.x = 0.0 ;
	Me_Forward.y = 1.0 ;
	Me_Forward.z = 0.0 ;
	Me_Up.x = 0.0 ;
	Me_Up.y = 0.0 ;
	Me_Up.z = 1.0 ;
	Me_Right.x = 1.0 ;
	Me_Right.y = 0.0 ;
	Me_Right.z = 0.0 ;
	Me_Delta.x = 0.0 ;
	Me_Delta.y = 0.0 ;
	Me_Delta.z = 0.0 ;
	Me_Speed = DEFAULT_SPEED ;
	Me_Speed_z = 0.0 ;
	Me_Throttle = Me_Power = .65 ;

	Kp1 = 0.7 ;
	Ks1 = 0.5 ;
	Vs0 = 20 ;		/* 40 knots stall speed */
	Zs = 2 ;
	Ksf = 0.3 ;
	PowerMax = 67052.0 ;	/* power, in watts (89 hp?) */
	Me_Mass = 907 ;		/* c-172 weighs 2000 lb full */
	Dind = 21.38 ;		/* induced drag, kg/sec */
	Dpar = 0.0 ;

	cloud_1 = cloud_2 = 0 ;
	cloud_base_1 = 1000.0 * FEET ;
	cloud_tops_1 = 2000.0 * FEET ;
	cloud_base_2 = 4000.0 * FEET ;
	cloud_tops_2 = 5000.0 * FEET ;
	visibility = 100.0 * MILES ;
	vis_sq = visibility*visibility ;
	vis_2 = visibility/2.0 ;
	vis_2_sq = vis_2*vis_2 ;
	wind_dir = wind_speed = wind_sin = wind_cos = 0. ;

	hood = 0 ;
	map = 0 ;
	maprange = 100000. ;		/* 100 km */
	trail = 0 ;
	trail_ptr = trail_num = 0 ;
	trail_dtime = 0. ;
	load_map() ;

	hwdb = pw_dbl_get(Main_pw,PW_DBL_AVAIL) ;
	if( hwdb )
	  pw_dbl_access( Main_pw ) ;

	Color_init() ;
	if (hwdb)		/* Pell */
	  Gfx_dbuf_write_mask(Main_gfx, 0xff) ;
	else			/* Pell */
	  Gfx_dbuf_write_mask(Main_gfx, 0xf) ; /* Pell */

	Gfx_persp_window_mat(0.,5.,-5.,5.,-2.5,2.5,5.,visibility,P_matrix) ;

	c = GREEN ;
	if( !hwdb )
	  c = Gfx_dbuf_get_color(Main_gfx, c) ;

#ifdef	COMMENT
	cursor_set(Main_Cursor, CURSOR_OP, PIX_SRC|PIX_DST|PIX_COLOR(c), 0) ;
	cursor_set(Default_Cursor, CURSOR_OP, PIX_SRC|PIX_DST|PIX_COLOR(c), 0) ;
#endif	COMMENT


	Left_But = 0 ;
	Middle_But = 0 ;
	Right_But = 0 ;
	Side_1 = Side_2 = Side_3 = Side_4 = Side_5 =
	Side_6 = Side_7 = Side_8 = Side_9 = Side_10 = 0 ;

	First_Time.tv_sec = -1 ;
	nframes = 0 ;

	mouse_control = 0 ;

	Init_panel() ;

	init_instruments() ;

	window_fit_height(Props_panel) ;
	window_fit_height(Props_frame) ;

	Init_Terrain() ;
	Init_Runways() ;
	Init_Stars() ;


	notify_set_signal_func(&Main_Timer, sigint, SIGHUP, NOTIFY_SYNC) ;
	notify_set_signal_func(&Main_Timer, sigint, SIGINT, NOTIFY_SYNC) ;
	notify_set_signal_func(&Main_Timer, sigint, SIGTERM, NOTIFY_SYNC) ;
	notify_set_signal_func(&Main_Timer, sigint, SIGXCPU, NOTIFY_SYNC) ;

#ifndef DEV_PW_DEFINED			/* Pell */
	(void) notify_set_itimer_func(&Main_Timer, timefunc,
		ITIMER_REAL, &Main_Timer, 0) ;

	window_main_loop(Main_Frame) ;
#else				/* Pw_lib: go as fast as possible */
	window_set(Main_Frame, WIN_SHOW, TRUE, 0);
	while (TRUE) {
	  notify_dispatch();
	  timefunc();
	}
#endif
	exit(0) ;
}








/* interrupt handler.  Simply tells the notifier to get the hell out */


static	int
sigint(me, signal, when)
	int	*me, signal ;
	Notify_signal_mode when ;
{
	window_set(Main_Frame, FRAME_NO_CONFIRM, TRUE, 0);
	window_destroy(Main_Frame) ;
}






/* this routine called whenever the clock ticks.  Current mode affects
   what happens */


void
timefunc(client, which)
	int	*client ;
	int	which ;
{
	long	interval ;
static	int	dtime_debug = 0 ;

	gettimeofday(&Now, NULL) ;
	if(Last_Time.tv_sec == -1)
	  Last_Time = Now ;

	Dtime = (Now.tv_sec - Last_Time.tv_sec) + 
		(Now.tv_usec - Last_Time.tv_usec) * .000001 ;
#ifdef	DEBUG
	if( dtime_debug == 1 )
	  Dtime = .1 ;
	else if( dtime_debug == 2 )
	  Dtime = 0.0 ;
#endif	DEBUG

	get_input() ;
	control_ship() ;	/* read inputs, set position */
	notify_dispatch();
	report_rate() ;
	draw_image() ;

	Last_Time = Now ;
}






/* this routine called whenever the clock ticks while asleep. */


void
sleepfunc(client, which)
	int	*client ;
	int	which ;
{
	long	interval ;

	gettimeofday(&Now, NULL) ;

	Last_Time = Now ;
}




static
report_rate()
{
	char	line[40] ;
	float	dtime ;
	float	rate ;

	if(First_Time.tv_sec == -1)
	  First_Time = Now ;
	else
	{
	  ++nframes ;
	  if(nframes%10 == 0)
	  {
	    dtime = (Now.tv_sec - First_Time.tv_sec) +
		    (Now.tv_usec - First_Time.tv_usec)*.000001 ;

	    rate = nframes/dtime ;
	    sprintf(line,"%7.2f %4d %8.3f",dtime,nframes,rate) ;
	    window_set(Main_Frame, FRAME_LABEL, line, 0) ;
	    First_Time = Now ;
	    nframes = 0 ;
	  }
	}
}





/****
 *
 * read control inputs, update ship's position/velocity/"up" vectors
 *
 ****/

static
get_input()
{
	Rect		*rect, *Gfx_rect() ;

	rect = Gfx_rect(Main_gfx) ;

	Mouse_ax = (float) Mouse_x / rect->r_width ;
	Mouse_ay = 1.0 - (float) Mouse_y / rect->r_height ;
}






static	void
Canvas_Proc(window, event, arg)
	Window	window ;
	Event	*event ;
	caddr_t	arg ;
{
	Cursor	new_cursor ;

	Mouse_x = event_x(event) ;
	Mouse_y = event_y(event) ;

	switch(event_id(event))
	{
	  case MS_LEFT:
	  case MS_MIDDLE:
	  case MS_RIGHT:
	  case LOC_DRAG:
	  case LOC_MOVE:
	  case LOC_WINEXIT:
	  case LOC_RGNEXIT:
	    if( !instrument_input(event) )
	    {
	      switch(event_id(event))
	      {
		case MS_LEFT:
		  Left_But = event_is_down(event) ;
		  if(Left_But)
		  {
		    mouse_control = !mouse_control ;
		    if(!mouse_control)
		      new_cursor = Default_Cursor ;
		    else
		      new_cursor = Main_Cursor ;
		    window_set(Main_Canvas, WIN_CURSOR, new_cursor, 0) ;
		  }
	      }
	    }
	    break ;

	  case KEY_LEFT(1):
	  case WIN_STOP:
	  case KEY_RIGHT(1):
	    Side_1 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(2):
	  case KEY_RIGHT(2):
	    Side_2 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(3):
	  case KEY_RIGHT(4):
	    panel_start() ;
	    break ;

	  case KEY_LEFT(4):
	  case KEY_RIGHT(5):
	    Side_4 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(6):
	  case KEY_RIGHT(8):
	    Side_6 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(5):
	  case KEY_LEFT(7):
	    win_post_event(Main_Frame, event, NOTIFY_SAFE) ;
	    break ;

	  case KEY_LEFT(8):
	  case KEY_RIGHT(11):
	    Side_8 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(9):
	  case KEY_RIGHT(13):
	    Side_9 = event_is_down(event) ;
	    break ;

	  case KEY_LEFT(10):
	  case KEY_RIGHT(14):
	    Side_10 = event_is_down(event) ;
	    break ;

	  case LOC_WINENTER:
	  case LOC_RGNENTER:
	    Left_But = (int) window_get(window, WIN_EVENT_STATE, MS_LEFT) ;
	    Middle_But = (int) window_get(window, WIN_EVENT_STATE, MS_MIDDLE) ;
	    Right_But = (int) window_get(window, WIN_EVENT_STATE, MS_RIGHT) ;
	    Side_1 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(1)) ;
	    Side_2 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(2)) ;
	    Side_3 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(3)) ;
	    Side_4 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(4)) ;
	    Side_5 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(5)) ;
	    Side_6 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(6)) ;
	    Side_7 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(7)) ;
	    Side_8 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(8)) ;
	    Side_9 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(9)) ;
	    Side_10 = (int) window_get(window, WIN_EVENT_STATE, KEY_LEFT(10)) ;
	    break ;
	  
	  case 'd':
	    printf("posn   =(%8.1f,%8.1f,%8.1f)\n",
		Me_Posn.x,Me_Posn.y,Me_Posn.z) ;
	    printf("forward=(%8.4f,%8.4f,%8.4f)\n",
		Me_Forward.x,Me_Forward.y,Me_Forward.z) ;
	    printf("up     =(%8.4f,%8.4f,%8.4f)\n",
		Me_Up.x,Me_Up.y,Me_Up.z) ;
	    printf("right  =(%8.4f,%8.4f,%8.4f)\n",
		Me_Right.x,Me_Right.y,Me_Right.z) ;
	    break ;

	  case 'h':
	    hood = !hood ;
	    break ;

	  case 'm':
	    map = !map ;
	    break ;

	  case '>':
	    maprange *= .5 ;
	    break ;

	  case '<':
	    maprange *= 2. ;
	    break ;

	  case 't':
	    trail = !trail ;
	    break ;
	}
}



static	void
Canvas_Resize_Proc(canvas, width, height)
	Canvas	canvas ;
	int	width, height ;
{
	resize_instruments(width, height) ;
}



static	Notify_value
Destroy_func(frame, status)
	Frame	frame ;
	Destroy_status	status ;
{
	if(status != DESTROY_CHECKING)
	{
	  (void) notify_set_itimer_func(&Main_Timer, timefunc,
	      ITIMER_REAL, NULL, 0) ;
#ifdef DEV_PW_DEFINED		/* Pell */
	  exit(0);		/* Pell */
#endif				/* Pell */
	}

	return(notify_next_destroy_func(frame, status)) ;
}



static	Notify_value
Close_func(frame, event, arg, type)
	Frame			frame ;
	Event			*event ;
	Notify_arg		arg ;
	Notify_event_type	type ;
{
	int		closed_initial, closed_current ;
	Notify_value	value ;

	closed_initial = (int) window_get(frame, FRAME_CLOSED) ;

	value = notify_next_event_func(frame, event, arg, type) ;

	closed_current = (int) window_get(frame, FRAME_CLOSED) ;

	return( value ) ;
}
