/*	%Z%%M% %I% %E% SMI	*/

/*
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 */

#ifndef GRAPHICS_H
#define GRAPHICS_H


#ifndef window_hs_DEFINED
#include <sunwindow/window_hs.h>
#endif

#include "gfx.h"

#ifdef	COMMENT
#include "object_types.h"
#endif	COMMENT


#define	VIEW_MAT 0		/* final viewing matrix */
#define	TM1	1
#define	TM2	2
#define	MOD_MAT	3		/* composite modelling matrix */
#define	WIN_MAT	4		/* window transformation here */
#define	ROT_MAT	5		/* matrix that holds ship orientation */

#define	WHITE	0
#define	BLACK	1	/* BLACK-YELLOW are constant colors, 1 shade */
#define	LGREY	2
#define	GREY	3
#define	RED	4
#define	GREEN	5
#define	BLUE	6
#define	YELLOW	7
#define	TERRAIN	8	/* the color of terrain (shades of green) */
#define	CITY	9	/* the color of cities (shades of grey) */
#define	SKY	10	/* the color of the sky (shades of blue) */
#define	FOG	11	/* the color of distant terrain (geryish green) */
#define	CLOUD	12	/* the color of clouds (1 shade of grey) */



#define	Set_color(gfx,color)			\
{						\
	if(hwdb)				\
	{					\
	  Gfx_set_color((gfx),(color)) ;	\
	}					\
	else					\
	{					\
	  Gfx_dbuf_color((gfx),(color)) ;	\
	}					\
}



extern	Pixwin		*Main_pw ;
extern	struct pixfont	*Main_font, *Small_font ;

extern	Gfx_context	Main_gfx ;

	Matrix3df	P_matrix ;


	int	Mouse_x, Mouse_y ;
	int	Left_But, Middle_But, Right_But ;
	int	Side_1, Side_2, Side_3, Side_4, Side_5 ;
	int	Side_6, Side_7, Side_8, Side_9, Side_10 ;
	float	Mouse_ax, Mouse_ay ;
	int	hwdb ;
	int	mouse_control ;

	int	Color_Mapping[16][2] ;


#endif	GRAPHICS_H
