/*	@(#)instrument.h 1.3 89/02/21	*/

#ifndef	INSTRUMENT
#define	INSTRUMENT

typedef	struct instrument	{
	  int		(*redraw)() ;	/* redraw function, called when reqd. */
	  int		(*update)() ;	/* update function, called each frame */
	  int		(*fail)() ;	/* failure proc, enter failure mode */
	  int		(*input)() ;	/* handle input			*/
	  float		x0,y0, x1,y1 ;	/* position of instr. in NDC	*/
	  int		ix0,iy0, ix1,iy1 ;
	  unsigned short flags ;	/* flags			*/
	  float		dvalue ;	/* displayed value		*/
	  float		value ;		/* actual value			*/
	  Point2df	vec ;		/* displayed vector		*/
	  short		fstate ;	/* failure state (0=no failure)	*/
	  short		fcount ;	/* failure countdown		*/
	  float		error ;		/* instrument dependent		*/
	  float		error_rate ;	/* rate of deviation		*/
	  caddr_t	private ;	/* private data pointer		*/
	  struct instrument	*next ;
	} Instrument ;

#define	INS_ELECTRIC	0x1	/* needs electricity */
#define	INS_VACUUM	0x2	/* needs vacuum system */
#define	INS_STATIC	0x4	/* needs static system */
#define	INS_PITOT	0x8	/* needs pitot system */

#endif	INSTRUMENT
